WGLMakie is a WebGL backend for the [Makie.jl](https://www.github.com/MakieOrg/Makie.jl) plotting package, implemented using Three.js.

Read the docs for Makie and it's backends [here](http://docs.makie.org)

# Usage

```julia
using WGLMakie
scatter(rand(4))
```

In the REPL, this will open a browser tab, that will refresh on a new display.
In VSCode, this should open in the plotpane.
You can also embed plots in a Bonito webpage:

```julia
using Bonito
app = App() do session, request
    return DOM.div(
        DOM.h1("Some Makie Plots:"),
        meshscatter(1:4, color=1:4),
        meshscatter(1:4, color=rand(RGBAf, 4)),
        meshscatter(1:4, color=rand(RGBf, 4)),
        meshscatter(1:4, color=:red),
        meshscatter(rand(Point3f, 10), color=rand(RGBf, 10)),
        meshscatter(rand(Point3f, 10), marker=WGLMakie.Pyramid(Point3f(0), 1f0, 1f0)),
    )
end
isdefined(Main, :server) && close(server)
server = Bonito.Server(app, "127.0.0.1", 8082)
```

## Sponsors

<img src="https://github.com/MakieOrg/Makie.jl/blob/master/assets/BMBF_gefoerdert_2017_en.jpg?raw=true" width="300"/>
Förderkennzeichen: 01IS10S27, 2020

using Makie: register_computation!

# Javascript Plot type (there are only three right now)
js_plot_type(plot::Makie.AbstractPlot) = "Mesh"
js_plot_type(plot::Union{Scatter, Makie.Text}) = "Scatter"
js_plot_type(plot::Union{Lines, LineSegments}) = "Lines"

function serialize_three(scene::Scene, plot::Makie.PrimitivePlotTypes)
    mesh = create_shader(scene, plot)

    mesh[:plot_type] = js_plot_type(plot)
    mesh[:name] = string(Makie.plotkey(plot)) * "-" * string(objectid(plot))
    mesh[:visible] = plot.visible[]
    mesh[:uuid] = js_uuid(plot)
    mesh[:updater] = plot.attributes[:wgl_update_obs][]

    mesh[:overdraw] = plot.overdraw[]
    mesh[:transparency] = plot.transparency[]
    mesh[:zvalue] = Makie.zvalue2d(plot)
    mesh[:space] = plot.space[]

    if haskey(plot, :markerspace)
        mesh[:markerspace] = plot.markerspace[]
        mesh[:cam_space] = plot.markerspace[]
    else
        mesh[:cam_space] = plot.space[]
    end

    mesh[:uniforms][:uniform_clip_planes] = serialize_three(plot.uniform_clip_planes[])
    mesh[:uniforms][:uniform_num_clip_planes] = serialize_three(plot.uniform_num_clip_planes[])

    return mesh
end

function backend_colors!(attr, color_name = :scaled_color)
    # TODO: Shouldn't this be guaranteed?
    if !haskey(attr, :interpolate)
        Makie.add_input!(attr, :interpolate, false)
    end
    register_computation!(attr, [color_name, :interpolate, :fetch_pixel], [:uniform_color, :pattern]) do (color, interpolate, is_pattern), changed, last
        filter = interpolate ? :linear : :nearest
        if color isa Sampler
            return (color, is_pattern)
        elseif color isa AbstractMatrix || color isa AbstractArray{<:Any, 3}
            # TODO, don't construct a sampler every time
            return (Sampler(color, minfilter = filter), false)
        elseif color isa Union{Real, Colorant}
            return (color, false)
        else
            # Not a uniform color
            return (false, false)
        end
    end

    map!(attr, color_name, :vertex_color) do color
        color isa Real && return color
        return color isa AbstractVector ? color : false
    end

    return register_computation!(attr, [:alpha_colormap, :scaled_colorrange, :color_mapping_type], [:uniform_colormap, :uniform_colorrange]) do (cmap, crange, ctype), changed, last
        isnothing(crange) && return (false, false)
        cmap_minfilter = ctype === Makie.continuous ? :linear : :nearest
        cmap_changed = changed.alpha_colormap || changed.color_mapping_type
        cmap_s = cmap_changed ? Sampler(cmap, minfilter = cmap_minfilter) : nothing
        return (cmap_s, Vec2f(crange))
    end
end

function handle_color!(data, attr)
    set!(x) = haskey(attr, x) && (data[x] = attr[x])
    set!(:vertex_color)
    set!(:uniform_color)
    set!(:uniform_colormap)
    set!(:uniform_colorrange)
    set!(:highclip_color)
    set!(:lowclip_color)
    set!(:nan_color)
    return set!(:pattern)
end

function update_values!(updater, values::Bonito.LargeUpdate)
    isempty(values.data) && return
    updater[] = values
    return
end

function update_values!(updater, values)
    isempty(values) && return
    updater[] = values
    return
end

function plot_updates(args, changed)
    new_values = []
    # we currently dont handle update of these in JS
    disallowed = (:space, :markerspace)
    for (name, value) in pairs(args)
        if changed[name] && !isnothing(value) && !(name in disallowed)
            _val = if value isa Sampler
                [Int32[size(value.data)...], serialize_three(value.data)]
            else
                # Check if value is an array with all identical elements
                if Makie.is_vector_attribute(value) && length(value) > 1 && all(x -> x == value[1], value)
                    # Use compressed format for arrays with identical elements
                    Dict("value" => serialize_three(value[1]), "length" => length(value))
                else
                    serialize_three(value)
                end
            end
            push!(new_values, [name, _val])
        end
    end
    return new_values
end

function create_wgl_renderobject(callback, attr, inputs)
    # default case
    haskey(attr, :uniform_clip_planes) || Makie.add_computation!(attr, Val(:uniform_clip_planes))

    register_computation!(attr, inputs, [:wgl_renderobject, :wgl_update_obs]) do args, changed, last
        if isnothing(last)
            program = callback(args)
            return (program, Observable{Any}([]))
        else
            updates = plot_updates(args, changed)
            last.wgl_renderobject[:visible] = args.visible
            update_values!(last.wgl_update_obs, Bonito.LargeUpdate(updates))
            return nothing
        end
    end
    return attr[:wgl_renderobject][]
end

function add_primitive_shading!(scene::Scene, attr)
    scene_shading = Makie.get_shading_mode(scene)
    return map!(attr, :shading, :primitive_shading) do shading
        s = (shading ? scene_shading : shading)
        shading = s isa Bool ? s : (s !== NoShading)
        return shading
    end
end

function handle_color_getter!(uniform_dict)
    vertex_color = uniform_dict[:vertex_color]
    if vertex_color isa Union{Real, AbstractArray{<:Real}} && !(vertex_color isa Bool)
        uniform_dict[:vertex_color_getter] = """
            vec4 get_vertex_color(){
                vec2 norm = get_uniform_colorrange();
                float cmin = norm.x;
                float cmax = norm.y;
                float value = vertex_color;
                if (value <= cmax && value >= cmin) {
                    // in value range, continue!
                } else if (value < cmin) {
                    return get_lowclip_color();
                } else if (value > cmax) {
                    return get_highclip_color();
                } else {
                    // isnan is broken (of course) -.-
                    // so if outside value range and not smaller/bigger min/max we assume NaN
                    return get_nan_color();
                }
                float i01 = clamp((value - cmin) / (cmax - cmin), 0.0, 1.0);
                // 1/0 corresponds to the corner of the colormap, so to properly interpolate
                // between the colors, we need to scale it, so that the ends are at 1 - (stepsize/2) and 0+(stepsize/2).
                float stepsize = 1.0 / float(textureSize(uniform_colormap, 0));
                i01 = (1.0 - stepsize) * i01 + 0.5 * stepsize;
                return texture(uniform_colormap, vec2(i01, 0.0));
            }
        """
    end
    return
end

function assemble_particle_robj!(attr, data)
    pos_key = haskey(attr, :wgl_positions) ? :wgl_positions : :positions_transformed_f32c
    data[pos_key] = getproperty(attr, pos_key)
    handle_color!(data, attr)
    handle_color_getter!(data)

    data[:converted_rotation] = attr.converted_rotation
    data[:f32c_scale] = attr.f32c_scale

    # Uniforms will be set in JavaScript
    data[:model_f32c] = attr.model_f32c
    data[:px_per_unit] = 0.0f0
    data[:picking] = false
    data[:object_id] = UInt32(0)

    data[:depth_shift] = attr.depth_shift
    data[:transform_marker] = attr.transform_marker
    per_instance_keys = Set(
        [
            pos_key, :converted_rotation, :quad_offset, :quad_scale, :vertex_color,
            :intensity, :sdf_uv, :converted_strokecolor, :marker_offset, :markersize,
        ]
    )

    per_instance = filter(data) do (k, v)
        return k in per_instance_keys && !(Makie.isscalar(v))
    end

    filter!(data) do (k, v)
        return !(k in per_instance_keys && !(Makie.isscalar(v)))
    end

    return per_instance, data
end


function scatter_program(attr)
    dfield = attr.sdf_marker_shape === Cint(Makie.DISTANCEFIELD)
    atlas = attr.atlas
    distancefield = dfield ? NoDataTextureAtlas(size(atlas.data)) : false
    data = Dict(
        :resolution => Vec2f(0),
        :preprojection => Mat4f(I),
        :atlas_texture_size => Float32(size(atlas.data, 2)),
        :billboard => get(attr, :billboard, false),
        :distancefield => distancefield,

        :marker_offset => attr.marker_offset,
        # Optional if glyph_data is provided
        :sdf_uv => get(attr, :sdf_uv, Vec4f[]),
        :quad_scale => get(attr, :quad_scale, Vec2f[]),
        :quad_offset => get(attr, :quad_offset, Vec2f[]),
        :sdf_marker_shape => get(attr, :sdf_marker_shape, Vec2f[]),

        :strokewidth => attr.strokewidth,
        :converted_strokecolor => attr.converted_strokecolor,
        :glowwidth => attr.glowwidth,
        :glowcolor => attr.glowcolor,
        :pattern => get(attr, :pattern, false),
    )

    per_instance, uniforms = assemble_particle_robj!(attr, data)
    instance = uv_mesh(Rect2f(-0.5f0, -0.5f0, 1.0f0, 1.0f0))

    data = create_instanced_shader(
        per_instance, instance, uniforms,
        lasset("sprites.vert"),
        lasset("sprites.frag")
    )

    if haskey(attr, :glyph_data)
        data[:glyph_data] = attr.glyph_data
    end
    return data
end

function create_shader(scene::Scene, plot::Scatter)
    attr = plot.attributes
    markersym = :marker
    if attr[:marker][] isa FastPixel
        # TODO, can we do this more elegantly?
        map!(attr, :marker, :fast_pixel_marker) do marker
            return Rect
        end
        markersym = :fast_pixel_marker
    end
    Makie.all_marker_computations!(attr, markersym)
    register_computation!(attr, [:sdf_marker_shape, :marker, :font], [:glyph_data]) do (shape, markers, fonts), changed, last
        shape != 3 && return nothing
        data = get_scatter_data(scene, markers, fonts)
        dict = Dict(:atlas_updates => data)
        return (dict,)
    end

    map!(attr, [:marker, :scaled_color], :scatter_color) do marker, color
        if marker isa AbstractMatrix
            return to_color(marker)
        else
            return color
        end
    end
    # For image markers (should this be a plot attribute?)
    Makie.add_constant!(attr, :interpolate, true)

    # ComputePipeline.alias!(attr, :rotation, :converted_rotation)
    ComputePipeline.alias!(attr, :strokecolor, :converted_strokecolor)
    ComputePipeline.alias!(attr, :positions_transformed_f32c, :wgl_positions)

    Makie.add_computation!(attr, scene, Val(:meshscatter_f32c_scale))
    backend_colors!(attr, :scatter_color)
    inputs = [
        :wgl_positions,

        :vertex_color, :uniform_color, :uniform_colormap,
        :uniform_colorrange, :nan_color, :highclip_color,
        :lowclip_color, :pattern,

        :converted_rotation, :billboard, :quad_scale,
        :quad_offset, :sdf_uv, :sdf_marker_shape, :image,
        :strokewidth, :converted_strokecolor, :glowwidth,
        :glowcolor, :depth_shift, :atlas,
        :markerspace, :visible, :transform_marker, :f32c_scale,
        :model_f32c, :marker_offset, :glyph_data,
        :uniform_clip_planes, :uniform_num_clip_planes,
    ]
    return create_wgl_renderobject(scatter_program, attr, inputs)
end

function get_atlas_tracker(f, scene::Scene)
    screen = Makie.getscreen(scene, WGLMakie)
    if isnothing(screen) || isnothing(screen.session)
        @warn "No session found, returning empty atlas tracker"
        # TODO, it's not entirely clear in which case this can happen,
        # which is why we don't just error, but just assume there isn't anything tracked
        return f(Set{UInt32}())
    end
    session = screen.session
    atlas = Bonito.get_metadata(session, :wglmakie_scene_atlas, nothing)
    if isnothing(atlas)
        atlas = Set{UInt32}()
        Bonito.set_metadata!(session, :wglmakie_scene_atlas, atlas)
    end
    return f(atlas)
end

function get_scatter_data(scene::Scene, markers, fonts)
    return get_atlas_tracker(Makie.root(scene)) do tracker
        atlas = Makie.get_texture_atlas()
        _, new_glyphs = Makie.get_glyph_data(atlas, tracker, markers, fonts)
        return new_glyphs
    end
end

function get_glyph_data(scene::Scene, glyphs, fonts)
    return get_atlas_tracker(Makie.root(scene)) do tracker
        atlas = Makie.get_texture_atlas()
        glyph_hashes, new_glyphs = Makie.get_glyph_data(atlas, tracker, glyphs, fonts)
        return glyph_hashes, new_glyphs
    end
end

function register_text_computation!(attr, scene)
    map!(attr, [:text_blocks, :text_scales], :glyph_scales) do text_blocks, fontsize
        return Makie.map_per_glyph(text_blocks, Vec2f, Makie.to_2d_scale(fontsize))
    end
    return register_computation!(attr, [:glyphindices, :font_per_char, :glyph_scales], [:glyph_data]) do (glyphs, fonts, glyph_scales), changed, last
        hashes, updates = get_glyph_data(scene, glyphs, fonts)
        dict = Dict(
            :glyph_hashes => hashes,
            :atlas_updates => updates,
            :scales => serialize_three(glyph_scales)
        )
        return (dict,)
    end
end

function create_shader(scene::Scene, plot::Makie.Text)
    # billboard for text causes glyph to not align correctly, should always be false
    attr = plot.attributes
    haskey(attr, :interpolate) || Makie.add_input!(attr, :interpolate, false)
    Makie.add_computation!(attr, scene, Val(:meshscatter_f32c_scale))
    backend_colors!(attr, :text_color)
    register_text_computation!(attr, scene)

    ComputePipeline.alias!(attr, :text_rotation, :converted_rotation)
    ComputePipeline.alias!(attr, :text_strokecolor, :converted_strokecolor)
    ComputePipeline.alias!(attr, :per_char_positions_transformed_f32c, :wgl_positions)
    inputs = [
        :wgl_positions,

        :vertex_color, :uniform_color, :uniform_colormap, :uniform_colorrange,
        :nan_color, :highclip_color, :lowclip_color, :pattern,
        :strokewidth, :glowwidth, :glowcolor,

        :converted_rotation, :converted_strokecolor,
        :marker_offset, :sdf_marker_shape, :glyph_data,
        # :quad_scale, :quad_offset, :sdf_uv,
        :depth_shift, :atlas, :markerspace,

        :visible, :transform_marker, :f32c_scale, :model_f32c,
        :uniform_clip_planes, :uniform_num_clip_planes,
    ]
    return create_wgl_renderobject(scatter_program, attr, inputs)
end


to_3x3(mat::Mat{3, 3}) = mat
to_3x3(M::Mat{2, 3}) = Mat3f(M[1], M[2], 0, M[3], M[4], 0, M[5], M[6], 1)
to_3x3(xs::Vector{Vec2f}) = Sampler(xs) # already has appropriate format

function meshscatter_program(args)
    instance = Dict(
        :vertex_position => args.vertex_position,
        :faces => args.faces,
        :normal => args.normal,
    )
    if !isnothing(args.uv)
        instance[:uv] = args.uv
    end
    data = Dict{Symbol, Any}(
        :diffuse => args.diffuse,
        :specular => args.specular,
        :shininess => args.shininess,
        :pattern => false,
        :uniform_color => false,
        :wgl_uv_transform => args.wgl_uv_transform,
        :PICKING_INDEX_FROM_UV => false,
        :shading => args.primitive_shading,
        :backlight => args.backlight,
        :interpolate_in_fragment_shader => false,
        :markersize => args.markersize,
        :f32c_scale => args.f32c_scale,
        # Note: uv needs to be generated via register_computation! to allow updates
        :uv => Vec2f(0),
    )
    per_instance, uniforms = assemble_particle_robj!(args, data)
    return create_instanced_shader(
        per_instance, instance, uniforms,
        lasset("particles.vert"),
        lasset("mesh.frag")
    )
end


function create_shader(scene::Scene, plot::MeshScatter)
    attr = plot.attributes

    Makie.add_computation!(attr, Val(:disassemble_mesh), :marker)
    Makie.add_computation!(attr, scene, Val(:uv_transform_packing))
    map!(to_3x3, attr, :packed_uv_transform, :wgl_uv_transform)
    Makie.add_computation!(attr, scene, Val(:meshscatter_f32c_scale))
    Makie.register_world_normalmatrix!(attr)
    haskey(attr, :interpolate) || Makie.add_input!(attr, :interpolate, false)
    backend_colors!(attr)
    add_primitive_shading!(scene, attr)
    ComputePipeline.alias!(attr, :rotation, :converted_rotation)

    inputs = [
        :vertex_position, :faces, :normal, :uv, # marker mesh
        :uniform_colormap, :uniform_color, :uniform_colorrange, :vertex_color,
        :wgl_uv_transform, :pattern,
        :positions_transformed_f32c, :markersize, :converted_rotation, :f32c_scale,
        :lowclip_color, :highclip_color, :nan_color, :matcap,
        :fetch_pixel, :model_f32c,
        :space,
        :diffuse, :specular, :shininess, :backlight, :world_normalmatrix,
        :transform_marker, :primitive_shading, :depth_shift,
        :uniform_clip_planes, :uniform_num_clip_planes, :visible,
    ]
    return create_wgl_renderobject(meshscatter_program, attr, inputs)
end

# TODO, speed up GeometryBasics
function fast_uv(nvertices)
    xrange, yrange = LinRange.((0, 1), (1, 0), nvertices)
    return [Vec2f(x, y) for y in yrange for x in xrange]
end
xy_convert(x::Makie.EndPoints, n) = LinRange(x..., n + 1)
xy_convert(x::AbstractArray, n) = x

import Makie: EndPoints

function add_uv_mesh!(attr)
    if !haskey(attr, :positions)
        register_computation!(
            attr, [:data_limits, :x, :y, :image, :transform_func],
            [:faces, :texturecoordinates, :wgl_positions]
        ) do (rect, x, y, z, t), changed, last

            if x isa EndPoints && y isa EndPoints && Makie.is_identity_transform(t)
                init = isnothing(last) # these are constant after init
                faces = init ? decompose(GLTriangleFace, Rect2f(rect)) : nothing
                uv = init ? decompose_uv(Rect2f(rect)) : nothing
                return (faces, uv, decompose(Point2d, Rect2d(rect)))
            else
                px = WGLMakie.xy_convert(x, size(z, 1))
                py = WGLMakie.xy_convert(y, size(z, 2))
                grid_ps = Makie.matrix_grid(px, py, zeros(length(px), length(py)))
                res = (length(px), length(py))
                faces = WGLMakie.fast_faces(res)
                uv = WGLMakie.fast_uv(res)
                return (faces, uv, grid_ps)
            end
        end
        Makie.register_position_transforms!(attr, input_name = :wgl_positions, transformed_name = :positions_transformed)
    else
        _rect = Rect2f(0, 0, 1, 1)
        add_constant!(attr, :faces, decompose(GLTriangleFace, _rect))
        add_constant!(attr, :texturecoordinates, decompose_uv(_rect))
    end

    if !haskey(attr, :normals)
        Makie.add_constants!(
            attr, normals = nothing, primitive_shading = false,
            diffuse = Vec3f(0), specular = Vec3f(0), shininess = 0.0f0, backlight = 0.0f0
        )
    end
    return if !haskey(attr, :wgl_uv_transform)
        Makie.add_constant!(attr, :wgl_uv_transform, Makie.uv_transform(:flip_y))
    end
end

function mesh_program(attr)

    data = Dict(
        :shading => attr.primitive_shading,
        :diffuse => attr.diffuse,
        :specular => attr.specular,
        :shininess => attr.shininess,
        :backlight => attr.backlight,

        :model_f32c => attr.model_f32c,
        :PICKING_INDEX_FROM_UV => true,
        :wgl_uv_transform => attr.wgl_uv_transform,
        :depth_shift => attr.depth_shift,
        :world_normalmatrix => attr.world_normalmatrix,
        :interpolate_in_fragment_shader => true
    )

    handle_color!(data, attr)
    # id + picking gets filled in JS, needs to be here to emit the correct shader uniforms
    data[:picking] = false
    data[:object_id] = UInt32(0)
    is_vertex((_, x)) = begin
        (x isa AbstractVector) && !Makie.is_scalar_attribute(x) && (length(x) == length(attr.positions_transformed_f32c))
    end
    uniforms = filter(!is_vertex, data)
    buffers = filter(is_vertex, data)
    if !isnothing(attr.normals)
        buffers[:normals] = attr.normals
    else
        uniforms[:normals] = Vec3f(0)
    end
    if !isnothing(attr.texturecoordinates)
        buffers[:texturecoordinates] = attr.texturecoordinates
    else
        uniforms[:texturecoordinates] = Vec2f(0)
    end
    buffers[:positions_transformed_f32c] = attr.positions_transformed_f32c
    buffers[:faces] = attr.faces

    return create_shader(buffers, uniforms, lasset("mesh.vert"), lasset("mesh.frag"))
end

function create_shader(::Scene, plot::Union{Heatmap, Image})
    attr = plot.attributes
    if plot isa Image
        map!(to_3x3, attr, :uv_transform, :wgl_uv_transform)
    end
    add_uv_mesh!(attr)
    backend_colors!(attr)
    Makie.register_world_normalmatrix!(attr)

    inputs = [
        # Special
        :space,
        # Needs explicit handling
        :uniform_colormap, :uniform_color, :vertex_color, :uniform_colorrange, :color_mapping_type, :pattern, :interpolate,
        :lowclip_color, :highclip_color, :nan_color, :model_f32c,
        :diffuse, :specular, :shininess, :backlight, :world_normalmatrix,
        :wgl_uv_transform, :fetch_pixel, :primitive_shading,
        :depth_shift, :positions_transformed_f32c, :faces, :normals, :texturecoordinates,
        :uniform_clip_planes, :uniform_num_clip_planes, :visible,
    ]
    return create_wgl_renderobject(mesh_program, attr, inputs)
end

function create_shader(scene::Scene, plot::Makie.Mesh)
    attr = plot.attributes
    Makie.register_world_normalmatrix!(attr)
    map!(to_3x3, attr, :pattern_uv_transform, :wgl_uv_transform)
    backend_colors!(attr)
    add_primitive_shading!(scene, attr)
    inputs = [
        # Special
        :space,
        # Needs explicit handling
        :uniform_colormap, :uniform_color, :vertex_color, :uniform_colorrange, :pattern,
        :lowclip_color, :highclip_color, :nan_color, :model_f32c, :matcap,
        :diffuse, :specular, :shininess, :backlight, :world_normalmatrix,
        :wgl_uv_transform, :fetch_pixel, :primitive_shading, :color_mapping_type,
        :depth_shift, :positions_transformed_f32c, :faces, :normals, :texturecoordinates,
        :uniform_clip_planes, :uniform_num_clip_planes, :visible,
    ]
    return create_wgl_renderobject(mesh_program, attr, inputs)
end


# TODO, speed up GeometryBasics
function fast_faces(nvertices)
    w, h = nvertices
    idx = LinearIndices(nvertices)
    nfaces = 2 * (w - 1) * (h - 1)
    faces = Vector{GLTriangleFace}(undef, nfaces)
    face_idx = 1
    @inbounds for i in 1:(w - 1)
        for j in 1:(h - 1)
            a, b, c, d = idx[i, j], idx[i + 1, j], idx[i + 1, j + 1], idx[i, j + 1]
            faces[face_idx] = GLTriangleFace(a, b, c)
            face_idx += 1
            faces[face_idx] = GLTriangleFace(a, c, d)
            face_idx += 1
        end
    end
    return faces
end

function create_shader(scene::Scene, plot::Surface)
    attr = plot.attributes
    Makie.add_computation!(attr, Val(:surface_as_mesh))
    Makie.register_world_normalmatrix!(attr)
    Makie.add_computation!(attr, scene, Val(:pattern_uv_transform))
    backend_colors!(attr)

    map!(attr, [:pattern_uv_transform, :z, :pattern], :wgl_uv_transform) do uvt, zs, is_pattern
        is_pattern && return to_3x3(uvt) # no rescaling, just shifting
        # Rescale and shift uvs so that vertices map to pixel centers in the texture
        # if the texture size and grid size match (i.e. no explicit `color = tex`)
        s = size(zs)
        scale = Vec2f((s .- 1) ./ s)
        trans = Vec2f(0.5 ./ s)
        # order matters, e.g. for :rotr90
        return to_3x3(uvt) * Makie.uv_transform(trans, scale)
    end
    Makie.add_computation!(attr, Val(:uniform_clip_planes))
    add_primitive_shading!(scene, attr)
    inputs = [
        # Special
        :space,
        # Needs explicit handling
        :uniform_colormap, :uniform_color, :vertex_color, :uniform_colorrange, :pattern,
        :lowclip_color, :highclip_color, :nan_color, :model_f32c, :matcap,
        :diffuse, :specular, :shininess, :backlight, :world_normalmatrix,
        :wgl_uv_transform, :fetch_pixel, :primitive_shading, :color_mapping_type,
        :depth_shift, :positions_transformed_f32c, :faces, :normals, :texturecoordinates,
        :uniform_clip_planes, :uniform_num_clip_planes, :visible,
    ]
    return create_wgl_renderobject(mesh_program, attr, inputs)
end

function create_volume_shader(attr)
    box = GeometryBasics.mesh(Rect3f(Vec3f(0), Vec3f(1)))
    uniforms = Dict{Symbol, Any}(
        :modelinv => attr.modelinv,
        :isovalue => attr.isovalue,
        :isorange => attr.isorange,
        :absorption => attr.absorption,
        :algorithm => attr.algorithm,
        :diffuse => attr.diffuse,
        :specular => attr.specular,
        :shininess => attr.shininess,
        :model => attr.uniform_model,
        :depth_shift => attr.depth_shift,
        :samples => attr.samples,

        # these get filled in later by serialization, but we need them
        # as dummy values here, so that the correct uniforms are emitted
        :eyeposition => Vec3f(1),
        :picking => false,
        :object_id => UInt32(0),
    )
    handle_color!(uniforms, attr)
    return create_shader(box, uniforms, lasset("volume.vert"), lasset("volume.frag"))
end

function create_shader(scene::Scene, plot::Volume)
    attr = plot.attributes

    Makie.add_computation!(attr, scene, Val(:uniform_model)) # bit different from voxel_model
    Makie.add_computation!(attr, Val(:uniform_clip_planes), :model, :uniform_model)

    # TODO: reuse in clip planes
    register_computation!(attr, [:uniform_model], [:modelinv]) do (model,), changed, cached
        return (Mat4f(inv(model)),)
    end
    backend_colors!(attr)
    inputs = [
        # Special
        :space,
        # Needs explicit handling
        :vertex_color, :uniform_color, :uniform_colormap, :uniform_colorrange, :pattern,
        :modelinv, :algorithm, :absorption, :isovalue, :isorange,
        :diffuse, :specular, :shininess, :backlight, :depth_shift,
        :lowclip_color, :highclip_color, :nan_color,
        :uniform_model, :uniform_num_clip_planes, :uniform_clip_planes, :visible,
        :samples,
    ]
    return create_wgl_renderobject(create_volume_shader, attr, inputs)
end


function create_lines_data(islines, attr)
    uniforms = Dict(
        :model_f32c => attr.model_f32c,
        :depth_shift => attr.depth_shift,
        :picking => false,
        :linecap => attr.linecap,
        :scene_origin => attr.scene_origin,
    )

    if islines
        uniforms[:joinstyle] = attr.joinstyle
        uniforms[:miter_limit] = attr.gl_miter_limit
    end

    uniforms[:uniform_pattern] = attr.uniform_pattern
    uniforms[:uniform_pattern_length] = attr.uniform_pattern_length

    handle_color!(uniforms, attr)

    attributes = Dict{Symbol, Any}(
        :positions_transformed_f32c => serialize_buffer_attribute(attr.positions_transformed_f32c),
    )

    for name in [:line_color, :uniform_linewidth]
        vals = attr[name]
        if Makie.is_scalar_attribute(vals)
            uniforms[name] = vals
        else
            attributes[name] = serialize_buffer_attribute(vals)
        end
    end

    return Dict(
        :plot_type => "Lines",
        :visible => attr.visible,
        :is_segments => !islines,
        :cam_space => attr.space,
        :uniforms => serialize_uniforms(uniforms),
        :attributes => attributes,
        :transparency => attr.transparency,
    )
end

using Makie.ComputePipeline

function serialize_three(scene::Scene, plot::Union{Lines, LineSegments})
    attr = plot.attributes

    Makie.add_computation!(attr, :uniform_pattern, :uniform_pattern_length)
    backend_colors!(attr)

    islines = plot isa Lines

    Makie.add_computation!(attr, Val(:uniform_clip_planes), :clip)

    inputs = [
        :positions_transformed_f32c,
        :line_color, :uniform_colormap, :uniform_colorrange, :color_mapping_type, :lowclip_color, :highclip_color, :nan_color,
        :linecap, :uniform_linewidth, :uniform_pattern, :uniform_pattern_length,
        :space, :scene_origin, :model_f32c, :depth_shift, :transparency, :visible,
        :uniform_clip_planes, :uniform_num_clip_planes,
    ]

    map!(attr, [:uniform_color, :vertex_color], :line_color) do uc, vc
        return vc == false ? uc : vc
    end
    if islines
        Makie.add_computation!(attr, :gl_miter_limit)
        push!(inputs, :joinstyle, :gl_miter_limit)
    end
    dict = create_wgl_renderobject(args -> create_lines_data(islines, args), attr, inputs)
    dict[:uuid] = js_uuid(plot)
    dict[:name] = string(Makie.plotkey(plot)) * "-" * string(objectid(plot))
    dict[:updater] = attr[:wgl_update_obs][]
    dict[:uniforms][:uniform_clip_planes] = serialize_three(plot.uniform_clip_planes[])
    dict[:uniforms][:uniform_num_clip_planes] = serialize_three(plot.uniform_num_clip_planes[])
    dict[:overdraw] = plot.overdraw[]
    dict[:zvalue] = Makie.zvalue2d(plot)
    return dict
end

function pick_native(screen::Screen, rect::Rect2i)
    (x, y) = minimum(rect)
    (w, h) = widths(rect)
    session = get_screen_session(screen)
    empty = Matrix{Tuple{Union{Nothing, AbstractPlot}, Int}}(undef, 0, 0)
    isnothing(session) && return empty
    scene = screen.scene
    picking_data = Bonito.evaljs_value(
        session, js"""
            Promise.all([$(WGL), $(scene)]).then(([WGL, scene]) => WGL.pick_native_matrix(scene, $x, $y, $w, $h))
        """
    )
    if isnothing(picking_data)
        return empty
    end
    w2, h2 = picking_data["size"]
    matrix = reshape(picking_data["data"], (w2, h2))
    if isempty(matrix)
        return empty
    else
        lookup = plot_lookup(scene)
        return map(matrix) do (uuid, index)
            !haskey(lookup, uuid) && return (nothing, 0)
            plt = lookup[uuid]
            return (plt, Int(index) + !(plt isa Volume))
        end
    end
end

function plot_lookup(scene::Scene)
    all_plots = Makie.collect_atomic_plots(scene)
    return Dict(Pair.(js_uuid.(all_plots), all_plots))
end

# Skips one set of allocations
function Makie.pick_closest(scene::Scene, screen::Screen, xy, range::Integer)
    # isopen(screen) || return (nothing, 0)
    xy_vec = Cint[round.(Cint, xy)...]
    range = round(Int, range)
    session = get_screen_session(screen)
    # E.g. if websocket got closed
    isnothing(session) && return (nothing, 0)
    selection = Bonito.evaljs_value(
        session, js"""
            Promise.all([$(WGL), $(scene)]).then(([WGL, scene]) => WGL.pick_closest(scene, $(xy_vec), $(range)))
        """
    )
    lookup = plot_lookup(scene)
    !haskey(lookup, selection[1]) && return (nothing, 0)
    plt = lookup[selection[1]]
    return (plt, Int(selection[2]) + !(plt isa Volume))
end

# Skips some allocations
function Makie.pick_sorted(scene::Scene, screen::Screen, xy, range)
    xy_vec = Cint[round.(Cint, xy)...]
    range = round(Int, range)
    session = get_screen_session(screen)
    # E.g. if websocket got closed
    isnothing(session) && return Tuple{Plot, Int}[]
    selection = Bonito.evaljs_value(
        session, js"""
            Promise.all([$(WGL), $(scene)]).then(([WGL, scene]) => {
                const picked = WGL.pick_sorted(scene, $(xy_vec), $(range))
                return picked
            })
        """
    )
    isnothing(selection) && return Tuple{Plot, Int}[]
    lookup = plot_lookup(scene)
    filter!(((id, idx),) -> haskey(lookup, id), selection)
    return map(selection) do (id, idx)
        plt = lookup[id]
        return (plt, Int(idx) + !(plt isa Volume))
    end
end

function Makie.pick(::Scene, screen::Screen, xy)
    plot_matrix = pick_native(screen, Rect2i(xy..., 1, 1))
    return plot_matrix[1, 1]
end

function Makie.pick(::Scene, screen::Screen, r::Rect2)
    return pick_native(screen, Rect2i(round.(minimum(r)), round.(widths(r))))
end

"""
    ToolTip(figurelike, js_callback; plots=plots_you_want_to_hover)

Returns a Bonito DOM element, which creates a popup whenever you click on a plot element in `plots`.
The content of the popup is filled with the return value of js_callback, which can be a string or `HTMLNode`.

Usage example:

```julia
App() do session
    f, ax, pl = scatter(1:4, markersize=100, color=Float32[0.3, 0.4, 0.5, 0.6])
    custom_info = ["a", "b", "c", "d"]
    on_click_callback = js\"\"\"(plot, index) => {
        // the plot object is currently just the raw THREEJS mesh
        console.log(plot)
        // Which can be used to extract e.g. position or color:
        const {pos, color} = plot.geometry.attributes
        console.log(pos)
        console.log(color)
        const x = pos.array[index*2] // everything is a flat array in JS
        const y = pos.array[index*2+1]
        const c = Math.round(color.array[index] * 10) / 10 // rounding to a digit in JS
        const custom = \$(custom_info)[index]
        // return either a string, or an HTMLNode:
        return "Point: <" + x + ", " + y + ">, value: " + c + " custom: " + custom
    }
    \"\"\"

    tooltip = WGL.ToolTip(f, on_click_callback; plots=pl)
    return DOM.div(f, tooltip)
end
```
"""
struct ToolTip
    scene::Scene
    callback::Bonito.JSCode
    plot_uuids::Vector{String}
    function ToolTip(figlike, callback; plots = nothing)
        scene = Makie.get_scene(figlike)
        if isnothing(plots)
            plots = scene.plots
        end
        all_plots = js_uuid.(filter!(x -> x.inspectable[], Makie.collect_atomic_plots(plots)))
        return new(scene, callback, all_plots)
    end
end

const POPUP_CSS = Bonito.Asset(@path joinpath(@__DIR__, "popup.css"))

function Bonito.jsrender(session::Session, tt::ToolTip)
    scene = tt.scene
    popup = DOM.div("", class = "popup")
    Bonito.evaljs(
        session, js"""
            $(scene).then(scene => {
                const plots_to_pick = new Set($(tt.plot_uuids));
                const callback = $(tt.callback);
                WGL.register_popup($popup, scene, plots_to_pick, callback)
            })
        """
    )
    return DOM.span(Bonito.jsrender(session, POPUP_CSS), popup)
end

using Bonito, WGLMakie, Makie

function handler(session, request)
    return scatter(1:4, color = 1:4)
end

dir = joinpath(@__DIR__, "exported")
isdir(dir) || mkdir(dir)
Bonito.export_standalone(handler, dir)
# Then serve it with e.g. LiveServer
using LiveServer

LiveServer.serve(dir = dir)

ENV["ENABLE_COMPUTE_CHECKS"] = "true"
ENV["ELECTRON_LOG_FILE"] = joinpath(@__DIR__, "electron.log")
ENV["ELECTRON_ENABLE_LOGGING"] = "true"

using FileIO
using WGLMakie, Makie, Test
using WGLMakie.Bonito
using ReferenceTests
using Makie: N0f8, RGBA
import Electron

@testset "mimes" begin
    Makie.inline!(true)
    f, ax, pl = scatter(1:4)
    @testset for mime in Makie.WEB_MIMES
        @test showable(mime(), f)
    end
    # I guess we explicitly don't say we can show those since it's highly Inefficient compared to html
    # See: https://github.com/MakieOrg/Makie.jl/blob/master/WGLMakie/src/display.jl#L66-L68=
    @test !showable("image/png", f)
    @test !showable("image/jpeg", f)
    # see https://github.com/MakieOrg/Makie.jl/pull/2167
    @test !showable("blaaa", f)
end

excludes = Set(
    [
        "Image on Surface Sphere", # TODO: texture rotated 180°
        "Array of Images Scatter", # scatter does not support texture images
        "Order Independent Transparency",
        "Mesh with 3d volume texture", # Not implemented yet
        "matcap", # not yet implemented
    ]
)

Makie.inline!(Makie.automatic)
edisplay = Bonito.use_electron_display(devtools = true)

@testset "reference tests" begin
    WGLMakie.activate!()

    @testset "ComputeGraph Sanity Checks" begin
        # This is supposed to catch changes in ComputePipeline causing nodes to
        # be skipped or become duplicated. This will also trigger if plot attributes
        # are modified in which case the numbers should just be updated
        f, a, p = scatter(rand(10))
        colorbuffer(f)
        @test length(p.attributes.inputs) == 42
        @test length(p.attributes.outputs) == 96
    end

    @testset "refimages" begin
        ReferenceTests.mark_broken_tests(excludes)
        recorded_files, recording_dir = @include_reference_tests WGLMakie "refimages.jl" joinpath(@__DIR__, "html_widgets_refimages.jl")
        missing_images, scores = ReferenceTests.record_comparison(recording_dir, "WGLMakie")
        ReferenceTests.test_comparison(scores; threshold = 0.05)
    end

    @testset "js texture atlas" begin
        atlas = Makie.get_texture_atlas()
        marker = collect(keys(atlas.mapping))

        positions = map(enumerate(marker)) do (i, m)
            Point2f((i % 19) * 50, (i ÷ 19) * 50)
        end
        msize = map(marker) do m
            uv = atlas.uv_rectangles[atlas.mapping[m]]
            reverse(Vec2f((uv[Vec(3, 4)] .- uv[Vec(1, 2)]) .* 2048))
        end
        # Make sure all sdfs inside texture atlas are send to JS!
        s = Scene()
        cam2d!(s)
        scatter!(s, positions, marker = marker, markersize = msize, markerspace = :data)
        center!(s)
        img = colorbuffer(s)

        js_tex_atlas = evaljs_value(s.current_screens[1].session, js"WGL.get_texture_atlas().data")
        js_atlas_data = reshape(Bonito.decode_extension_and_addbits(js_tex_atlas), (2048, 2048))
        # Code to look at the atlas (reference test?)
        # f, ax, pl = contour(js_atlas_data, color=:red, levels=[0.0, 15.0], alpha=0.5)
        # hidedecorations!(ax)
        # pl = contour!(ax, atlas.data, color=:black, levels=[0.0, 15.0], alpha=1.0)
        # ax3, pl = image(f[1, 2], img, uv_transform=Mat{2,3,Float32}(0, 1, 1, 0, 0, 0))
        # hidedecorations!(ax3)
        # f
        @test atlas.data ≈ js_atlas_data
    end


    @testset "window open/closed" begin
        f, a, p = scatter(rand(10))
        @test events(f).window_open[] == false
        @test Makie.isclosed(f.scene) == false
        @test isempty(f.scene.current_screens) || !isopen(first(f.scene.current_screens))
        # This may take a bit
        @testset "screen closing after not begin displayed anymore" begin
            display(edisplay, App(f))
            Bonito.wait_for(() -> events(f).window_open[])
            @test !isempty(f.scene.current_screens)
            screen = f.scene.current_screens[1]
            @test events(f).window_open[] == true
            @test Makie.isclosed(f.scene) == false
            @test isopen(screen)
            display(edisplay, App(nothing))
            Bonito.wait_for(() -> events(f).window_open[] == false)
            @test !isopen(screen)
            @test events(f).window_open[] == false
            @test Makie.isclosed(f.scene) == true
        end
        @testset "screen with explicit close" begin
            f, a, p = scatter(rand(10))
            display(edisplay, App(f))
            Bonito.wait_for(() -> events(f).window_open[])
            @test !isempty(f.scene.current_screens)
            screen = f.scene.current_screens[1]
            @test events(f).window_open[] == true
            @test Makie.isclosed(f.scene) == false
            close(f.scene.current_screens[1])
            @test events(f).window_open[] == false
            @test Makie.isclosed(f.scene) == true
            @test Makie.isopen(f.scene) == false
        end
    end

    @testset "small float passthrough" begin
        scene = Scene()
        p1 = volume!(scene, fill(N0f8(0.5), 4, 4, 4)::Array{N0f8, 3})
        p2 = volume!(scene, fill(Float16(0.5), 4, 4, 4))
        p3 = volume!(scene, fill(RGBA{N0f8}(0.5, 0.5, 0.5, 0.5), 4, 4, 4), algorithm = :absorptionrgba)
        p4 = volume!(scene, fill(RGBA{Float16}(0.5, 0.5, 0.5, 0.5), 4, 4, 4), algorithm = :absorptionrgba)
        # p5 = mesh!(scene, Rect2f(0,0,1,1), color = rand(RGBA{N0f8}, 4, 4))
        # p6 = scatter!(scene, 1:4, color = rand(N0f8, 4))
        display(edisplay, App(scene))
        Bonito.wait_for(() -> events(scene).window_open[])
        sleep(2)

        @test eltype(p1.wgl_renderobject[][:uniforms][:uniform_color][:data]) === N0f8
        @test eltype(p2.wgl_renderobject[][:uniforms][:uniform_color][:data]) === Float16
        @test eltype(p3.wgl_renderobject[][:uniforms][:uniform_color][:data]) === UInt8 # RGBA gets splatted
        @test_broken eltype(p4.wgl_renderobject[][:uniforms][:uniform_color][:data]) === Float16 # can we allow Float16 to pass to js?
        # @test eltype(p5.gl_renderobject[][:image]) === RGBA{N0f8}
        # @test eltype(p6.gl_renderobject[].vertexarray.buffers["intensity"]) === N0f8
    end

    @testset "Tick Events" begin
        function check_tick(tick, state, count)
            @test tick.state == state
            @test tick.count == count
            @test tick.time > 1.0e-9
            @test tick.delta_time > 1.0e-9
        end

        @testset "save()" begin
            f, a, p = scatter(rand(10))
            @test events(f).tick[] == Makie.Tick()

            filename = "$(tempname()).png"
            try
                tick_record = Makie.Tick[]
                on(tick -> push!(tick_record, tick), events(f).tick)
                save(filename, f)
                idx = findfirst(tick -> tick.state == Makie.OneTimeRenderTick, tick_record)
                tick = tick_record[idx]
                @test tick.state == Makie.OneTimeRenderTick
                @test tick.count == 0
                @test tick.time == 0.0
                @test tick.delta_time == 0.0
            finally
                close(f.scene.current_screens[1])
                rm(filename)
            end
        end

        @testset "record()" begin
            f, a, p = scatter(rand(10))
            filename = "$(tempname()).mp4"
            try
                tick_record = Makie.Tick[]
                on(tick -> push!(tick_record, tick), events(f).tick)
                record(_ -> nothing, f, filename, 1:10, framerate = 30)

                start = findfirst(tick -> tick.state == Makie.OneTimeRenderTick, tick_record)
                dt = 1.0 / 30.0

                for (i, tick) in enumerate(tick_record[start:end])
                    @test tick.state == Makie.OneTimeRenderTick
                    @test tick.count == i - 1
                    @test tick.time ≈ dt * (i - 1)
                    @test tick.delta_time ≈ dt
                end
            finally
                rm(filename)
            end

            # test destruction of tick overwrite
            f, a, p = scatter(rand(10))
            colorbuffer(f) # trigger screen creation

            let
                io = VideoStream(f)
                @test events(f).tick[] == Makie.Tick(Makie.OneTimeRenderTick, 0, 0.0, 1.0 / io.options.framerate)
                nothing
            end
            tick = Makie.Tick(Makie.UnknownTickState, 1, 1.0, 1.0)
            events(f).tick[] = tick
            @test events(f).tick[] == tick
        end


        @testset "normal render()" begin
            f, a, p = scatter(rand(10))
            tick_record = Makie.Tick[]
            on(t -> push!(tick_record, t), events(f).tick)
            sleep(0.2)

            # should be empty (or at least not contain Render ticks yet?)
            @test isempty(tick_record)

            render_time = 20
            colorbuffer(f)
            sleep(render_time)
            close(f.scene.current_screens[1])
            sleep(5)

            # Check:
            # 1. `colorbuffer` started producing ticks at roughly 30 ticks/s
            # 2. `close` stopped tick production
            # To verify this we check that the number of ticks is proportional
            # to the real render time, which should be close to the sleep time.
            @test render_time * 30 - 1 <= length(tick_record) <= render_time * 30 + 20

            t = 0.0
            for (i, tick) in enumerate(tick_record)
                @test tick.state == Makie.RegularRenderTick
                @test tick.count == i
                @test tick.time > t
                t = tick.time
            end

            # Each tick aims to trigger at t = N * 1/30 + t0 where N is some
            # whole number. Consecutive ticks will usually be at N and N+1, but
            # can skip to N+2 or more if other sources delay them too much.
            # Sleep is also fairly inaccurate so the variance is rather large
            # Test: tick.time follow N * 1/30
            dt = 1 / 30
            dist_from_target = map(tick -> ((tick.time + 0.5dt) % dt) - 0.5dt, tick_record)
            t0 = mean(dist_from_target)
            dist_from_target .-= t0
            standard_error = sqrt(mapreduce(t -> t * t, +, dist_from_target) / length(dist_from_target))
            @test standard_error < 0.2dt

            # Ticks will usually get increasing delayed (or early) and eventually
            # correct themselves by sleeping less. This will then average out
            # to a lower error over multiple samples
            window = 10
            windowed_dist = [mean(dist_from_target[i:(i + window)]) for i in 1:(length(dist_from_target) - window)]
            standard_error = sqrt(mapreduce(t -> t * t, +, windowed_dist) / length(windowed_dist))
            @test standard_error < 0.05dt

            # delta times should average out to 1/30, with the caveat that ticks
            # can sometimes get skipped/merge into a N * 1/30 tick. Those ticks
            # need to count as N ticks in the mean then.
            # This is somewhat self-fulling...
            av = last(tick_record).time / round(Int, last(tick_record).time * 30)
            @test abs(av - dt) < 0.005dt
        end
    end

    @testset "html-widgets" begin
        include("html-widgets.jl")
    end

    @testset "memory leaks" begin
        Makie.CURRENT_FIGURE[] = nothing
        app = App(nothing)
        display(edisplay, app)
        GC.gc(true)
        # Somehow this may take a while to get emptied completely
        p_key = "Object.keys(WGL.plot_cache)"
        value = @time Bonito.wait_for(() -> (GC.gc(true); isempty(run(edisplay.window, p_key))); timeout = 50)
        @show run(edisplay.window, p_key)
        @test value == :success

        s_keys = "Object.keys(Bonito.Sessions.SESSIONS)"
        value = @time Bonito.wait_for(() -> (GC.gc(true); length(run(edisplay.window, s_keys)) == 2); timeout = 50)
        @show run(edisplay.window, s_keys)
        @show app.session[].id
        @show app.session[].parent
        # It seems, we don't free all sessions right now, which needs fixing.
        # @test value == :success

        wgl_plots = run(edisplay.window, "Object.keys(WGL.scene_cache)")
        @test isempty(wgl_plots)

        session = edisplay.browserdisplay.handler.session
        # Measure Bonito's own session state, NOT the transport layer underneath it.
        # `session.connection.handler.socket` is an HTTP.jl WebSocket whose send
        # buffer (`WSConn.outgoing`) retains the capacity of the largest frame ever
        # sent (by design: zero-alloc steady-state writes) and is freed only when the
        # connection closes. This is the *hot* page session, kept open for the whole
        # run, so a plain `summarysize` would charge it tens of MB of HTTP send-buffer
        # capacity that isn't session state. Stop the walk at the HTTP WebSocket
        # boundary; everything Bonito owns is still counted (verified: stashing an
        # array in `session_objects` still grows this number).
        http_socket_type = typeof(session.connection.handler.socket).name.wrapper
        session_size = Base.summarysize(
            session;
            exclude = Union{DataType, Core.TypeName, Core.MethodInstance, http_socket_type},
        ) / 10^6

        @test length(session.session_objects) == 0
        # getproperty, not getfield: in Bonito v5 `inbox` lives on the shared
        # RootSession and getfield would throw a FieldError (works via the shim on both).
        @testset "Session fields empty" for field in [:on_document_load, :stylesheets, :message_queue, :deregister_callbacks]
            @test isempty(getproperty(session, field))
        end
        # `inbox` is the live WS receive channel on the still-connected display
        # root, so a message can be mid-flight when we check — asserting it empty
        # instantly is racy. Give the reader task a moment to drain it; a genuinely
        # stuck reader (a real leak/hang) would still fail via the timeout.
        @test Bonito.wait_for(() -> isempty(getproperty(session, :inbox)); timeout = 10) == :success
        # Figure/widget assets are emitted into their sub-session's own fragment
        # and freed from the root when that sub closes, so after `App(nothing)`
        # the page root retains only its own connection shell (Bonito's
        # Websocket.js), not the WGLMakie/widget bundles. A count above this small
        # page-shell surface means sub imports are leaking onto the root again.
        @test length(session.imports) <= 2
        server = session.connection.server
        @test length(server.websocket_routes.table) == 1
        @test server.websocket_routes.table[1][2] == session.connection
        @test length(server.routes.table) == 2
        @test server.routes.table[1][1] == "/browser-display"
        @test server.routes.table[2][2] isa HTTPAssetServer

        # With the HTTP transport excluded, the hot session's own footprint is ~1.3 MB
        # (almost all of it the retained JS import bundle). Keep headroom for env
        # differences, but tight enough to catch a real multi-MB session leak.
        @show session_size
        @test session_size < 5

        js_sessions = run(edisplay.window, "Bonito.Sessions.SESSIONS")
        js_objects = run(edisplay.window, "Bonito.Sessions.GLOBAL_OBJECT_CACHE")
        # @test Set([app.session[].id, app.session[].parent.id]) == keys(js_sessions)
        # we used Retain for global_obs, so it should stay as long as root session is open
    end
end

println("###########################")
println("WGLMakie tests DONE")
println("Open Tasks: ", length(Makie.TRACKED_TASKS))
println("###########################")

module WGLMakie

using Hyperscript
using Bonito
using Observables
using Makie
using Colors
using ShaderAbstractions
using LinearAlgebra
using GeometryBasics
using PNGFiles
using FreeTypeAbstraction

using Bonito: Session
using Bonito: @js_str, onjs, App, ES6Module
using Bonito.DOM

using RelocatableFolders: @path

using ShaderAbstractions: VertexArray, Buffer, Sampler, AbstractSampler
using ShaderAbstractions: InstancedProgram
using GeometryBasics: StaticVector

import Makie.FileIO
using Makie: get_texture_atlas, SceneSpace, Pixel, Automatic
using Makie: MouseButtonEvent, KeyEvent
using Makie: apply_transform, transform_func_obs
using Makie: spaces, is_data_space, is_pixel_space, is_relative_space, is_clip_space
using Makie: f32_conversion_obs, f32_convert

struct WebGL <: ShaderAbstractions.AbstractContext end

const WGL = ES6Module(joinpath(@__DIR__, "javascript", "WGLMakie.js"))
# using as THREE version: "https://cdn.esm.sh/v66/three@0.173/es2021/three.js"

include("html-widgets.jl")
include("shader-abstractions.jl")
include("spinner.jl")
include("display.jl")
include("three_plot.jl")
include("serialization.jl")
include("events.jl")
include("plot-primitives.jl")
include("picking.jl")
include("voxel.jl")

const LAST_INLINE = Base.RefValue{Union{Automatic, Bool}}(Makie.automatic)

"""
    WGLMakie.activate!(; screen_config...)

Sets WGLMakie as the currently active backend and also allows to quickly set the `screen_config`.
Note, that the `screen_config` can also be set permanently via `Makie.set_theme!(WGLMakie=(screen_config...,))`.

# Arguments one can pass via `screen_config`:

$(Base.doc(ScreenConfig))
"""
function activate!(; inline::Union{Automatic, Bool} = LAST_INLINE[], screen_config...)
    Makie.inline!(inline)
    LAST_INLINE[] = inline
    Makie.set_active_backend!(WGLMakie)
    Makie.set_screen_config!(WGLMakie, screen_config)
    if !Bonito.has_html_display()
        Bonito.browser_display()
    end
    return
end

function __init__()
    # Activate WGLMakie as backend!
    activate!()
    return
end

# re-export Makie, including deprecated names
for name in names(Makie, all = true)
    if Base.isexported(Makie, name) && name !== :Button && name !== :Slider
        @eval using Makie: $(name)
        @eval export $(name)
    end
end

include("precompiles.jl")

end # module

# We use objectid to find objects on the js side
js_uuid(object) = string(objectid(object))

function Bonito.print_js_code(io::IO, plot::AbstractPlot, context::Bonito.JSSourceContext)
    uuids = js_uuid.(Makie.collect_atomic_plots(plot))
    # This is a bit more complicated then it has to be, since evaljs / on_document_load
    # isn't guaranteed to run after plot initialization in an App... So, if we don't find any plots,
    # we have to check again after inserting new plots
    return Bonito.print_js_code(
        io, js"""(new Promise(resolve => {
            $(WGL).then(WGL=> {
                const find = ()=> {
                    const plots = WGL.find_plots($(uuids))
                    if (plots.length > 0) {
                        resolve(plots)
                    } else {
                        WGL.on_next_insert(find)
                    }
                };
                find()
            })
        }))""", context
    )
end

function Bonito.print_js_code(io::IO, scene::Scene, context::Bonito.JSSourceContext)
    code = js"""$(WGL).then(WGL=> {
        function try_find_scene(_retries) {
            let retries = _retries || 0;
            const max_retries = 100;
            const retry_delay = 100;
            const scene = WGL.find_scene($(js_uuid(scene)));
            if (scene) {
                return Promise.resolve(scene);
            } else if (retries < max_retries) {
                return new Promise(resolve => {
                    setTimeout(() => {
                        try_find_scene(retries + 1).then(resolve);
                    }, retry_delay);
                });
            } else {
                return Promise.reject(new Error("Scene not found after retries"));
            }
        }
        return try_find_scene();
    })"""
    return Bonito.print_js_code(io, code, context)
end


function get_order!(session::Session)
    order = Bonito.get_metadata(session, :wglmakie_scene_order, 1)
    Bonito.set_metadata!(session, :wglmakie_scene_order, order + 1)
    return order
end

function three_display(screen::Screen, session::Session, scene::Scene)
    config = screen.config
    order = get_order!(session)
    window_open = scene.events.window_open
    initial_size = size(scene)
    canvas_width = lift(x -> [round.(Int, widths(x))...], scene, viewport(scene))
    is_offline = Bonito.root_session(session).connection isa Bonito.NoConnection
    # Observable to receive the actual canvas size from JS after resize_to calculation
    real_size = Observable{Any}(nothing)
    # Create observable for scene serialization that updates asynchronously
    scene_serialized = Observable{Union{Nothing, Dict{Symbol, Any}}}(nothing)
    done_init = Observable{Any}(nothing)
    if is_offline
        # For offline connections, we have to serialize immediately
        # Since we cant do any round trip communication
        scene_serialized[] = serialize_scene(scene)
    else
        # Query the real canvas size (resize_to) from JS first, resize the scene to
        # it, THEN serialize — so the browser renders at the final size directly
        # instead of rendering at `initial_size` and re-laying-out via observable
        # updates afterwards (which caused a visible resize + a race on capture).
        on(session, real_size) do size_arr
            Makie.async_tracked() do should_close
                try
                    size_tuple = (round.(Int, (size_arr))...,)
                    if size_tuple != initial_size
                        resize!(scene, size_tuple...)
                    end
                    scene_serialized[] = serialize_scene(scene)
                catch e
                    @warn "Error resizing/serializing scene" exception = (e, catch_backtrace())
                    done_init[] = e
                end
            end
            return
        end
    end
    width, height = initial_size
    # Create canvas
    canvas = DOM.m(
        "canvas";
        tabindex = "0",
        # Set with/height to have a good inital size - might not match the final size with scaling etc, but this
        # will be adjusted in JS - this helps with less re-layoting
        width = "$(width)px",
        height = "$(height)px",
        style = "display: block",
        # Pass JupyterLab specific attributes to prevent it from capturing keyboard shortcuts
        # and to suppress the JupyterLab context menu in Makie plots, see:
        # https://jupyterlab.readthedocs.io/en/4.2.x/extension/notebook.html#keyboard-interaction-model
        # https://jupyterlab.readthedocs.io/en/4.2.x/extension/extension_points.html#context-menu
        dataLmSuppressShortcuts = true, dataJpSuppressContextMenu = nothing,
    )

    # Get spinner from config (will be constructed from theming)
    # Wrapper contains canvas and spinner as siblings, plus widgets will be added later
    # position: relative is needed for:
    # 1. absolute positioning of spinner on top of canvas
    # 2. absolute positioning of widgets (HTML widgets, etc.)
    wrapper = DOM.div(canvas, config.spinner; style = "width: 100%; height: 100%; position: relative;")
    comm = Observable(Dict{String, Any}())

    # Keep texture atlas in parent session, so we don't need to send it over and over again
    evaljs(
        session, js"""
        $(WGL).then(WGL => {
            WGL.execute_in_order($order, ()=> {
                WGL.setup_scene_init(
                    $wrapper,
                    $canvas,
                    $width,
                    $height,
                    $(config.resize_to),
                    $(config.px_per_unit),
                    $(config.scalefactor),
                    $(real_size),
                    $canvas_width,
                    $(scene_serialized),
                    $comm,
                    $(config.framerate),
                    $(done_init)
                )
            })
        })
        """
    )
    # push!(Bonito.children(wrapper), jss)
    on(session, done_init) do val
        window_open[] = true
    end
    connect_scene_events!(screen, scene, comm)
    return wrapper, done_init
end

using Bonito, WGLMakie, Colors

# Global styles for widget containers
const WIDGET_CONTAINER_STYLES = Styles(
    "position" => "absolute",
    "padding" => "0px",
    "margin" => "0px",
    "display" => "flex",
    "align-items" => "center",
    "justify-content" => "center",
    "font-family" => "'TeXGyreHerosMakie', sans-serif",
    "white-space" => "nowrap"
)

const FONT_STYLE = Styles(
    CSS(
        "@font-face",
        "font-family" => "TeXGyreHerosMakie",
        "src" => Asset(assetpath("fonts", "TeXGyreHerosMakie-Regular.otf"))
    ),
)


function resize_parent(parent, block)
    scene = Makie.rootparent(block.blockscene)
    height_box = map(block.layoutobservables.computedbbox, scene.viewport; ignore_equal_values = true) do box, vp
        (xmin, ymin), (xmax, ymax) = extrema(box)
        fig_height = vp.widths[2]  # Get figure height
        return [fig_height, xmin, ymin, xmax, ymax]
    end
    return js"""
        $(scene).then(scene => {
            const div = $(parent);
            const {canvas, winscale} = scene.screen;

            // The wrapper (canvas.parentElement) has position: relative, so widgets
            // positioned absolute will be relative to the wrapper, not the document
            const wrapper = canvas.parentElement;

            // Update position when either bbox or viewport changes
            function update_position(height_box) {
                const [fig_height, xmin, ymin, xmax, ymax] = height_box;
                const web_top = fig_height - ymax;

                // Since the wrapper has position: relative and widgets are position: absolute,
                // widgets are positioned relative to the wrapper.
                // Canvas and widgets are both children of wrapper, so we just need the canvas offset
                // within the wrapper (which should be 0,0 since canvas is the first child)
                const canvasRect = canvas.getBoundingClientRect();
                const wrapperRect = wrapper.getBoundingClientRect();

                const offsetX = canvasRect.left - wrapperRect.left;
                const offsetY = canvasRect.top - wrapperRect.top;

                // Scale coordinates by winscale to match canvas CSS scaling
                // Canvas CSS size = logical_size * winscale (where winscale = scalefactor / devicePixelRatio)
                div.style.left = (xmin * winscale + offsetX) + "px";
                div.style.top = (web_top * winscale + offsetY) + "px";
                div.style.width = ((xmax - xmin) * winscale) + "px";
                div.style.height = ((ymax - ymin) * winscale) + "px";

                // Set CSS variable for winscale so children can use calc(var(--winscale) * 1px)
                div.style.setProperty('--winscale', winscale);
            }
            $(height_box).on(update_position);
            update_position($(height_box).value); // Initial positioning
        });
    """
end

function replace_widget!(slider::Makie.Slider)
    Makie.hide!(slider)
    initial_value = slider.value[]
    range_vals = slider.range[]
    min_val = minimum(range_vals)
    max_val = maximum(range_vals)
    step_val = length(range_vals) > 1 ? range_vals[2] - range_vals[1] : 0.01
    is_horizontal = slider.horizontal[]

    # Extract Makie styling attributes
    linewidth = slider.linewidth[]
    color_inactive = slider.color_inactive[]
    color_active = slider.color_active[]
    color_active_dimmed = slider.color_active_dimmed[]

    # Common style pairs to avoid duplication
    base_input = [
        "-webkit-appearance" => "none",
        "appearance" => "none",
        "margin" => "0",
        "padding" => "0",
        "outline" => "none",
        "cursor" => "pointer",
        "width" => "100%",
        "background" => "transparent",
    ]

    track_common = [
        "background" => color_inactive,
        "border-radius" => "calc(var(--winscale) * $(linewidth / 2) * 1px)",
    ]

    thumb_common = [
        "-webkit-appearance" => "none",
        "appearance" => "none",
        "width" => "calc(var(--winscale) * $(linewidth) * 1px)",
        "height" => "calc(var(--winscale) * $(linewidth) * 1px)",
        "border-radius" => "50%",
        "background" => color_active,
        "cursor" => "pointer",
        "border" => "none",
    ]

    # Build styles based on orientation
    input_styles, vertical_attrs = if is_horizontal
        styles = Styles(
            CSS(base_input...),
            CSS("::-webkit-slider-runnable-track", track_common..., "height" => "calc(var(--winscale) * $(linewidth) * 1px)"),
            CSS("::-webkit-slider-thumb", thumb_common..., "transition" => "transform 0.1s ease"),
            CSS(":hover::-webkit-slider-thumb", "transform" => "scale(1.25)"),
            # Firefox uses ::-moz-range-progress for the filled portion
            CSS("::-moz-range-track", track_common..., "height" => "calc(var(--winscale) * $(linewidth) * 1px)"),
            CSS(
                "::-moz-range-progress",
                "background" => color_active_dimmed,
                "border-radius" => "calc(var(--winscale) * $(linewidth / 2) * 1px)",
                "height" => "calc(var(--winscale) * $(linewidth) * 1px)",
            ),
            CSS("::-moz-range-thumb", thumb_common..., "transition" => "transform 0.1s ease"),
            CSS(":hover::-moz-range-thumb", "transform" => "scale(1.25)"),
        )
        (styles, Dict())
    else
        styles = Styles(
            CSS(
                base_input...,
                "writing-mode" => "vertical-lr",
                "direction" => "rtl",
                "vertical-align" => "middle",
                "width" => "calc(var(--winscale) * $(linewidth) * 1px)",
                "height" => "100%",
            ),
            CSS("::-webkit-slider-runnable-track", track_common..., "width" => "calc(var(--winscale) * $(linewidth) * 1px)"),
            CSS("::-webkit-slider-thumb", thumb_common..., "transition" => "transform 0.1s ease"),
            CSS(":hover::-webkit-slider-thumb", "transform" => "scale(1.25)"),
            CSS("::-moz-range-track", track_common..., "width" => "calc(var(--winscale) * $(linewidth) * 1px)", "height" => "100%"),
            CSS(
                "::-moz-range-progress",
                "background" => color_active_dimmed,
                "border-radius" => "calc(var(--winscale) * $(linewidth / 2) * 1px)",
                "width" => "calc(var(--winscale) * $(linewidth) * 1px)",
                "height" => "100%",
            ),
            CSS("::-moz-range-thumb", thumb_common..., "transition" => "transform 0.1s ease"),
            CSS(":hover::-moz-range-thumb", "transform" => "scale(1.25)"),
        )
        (styles, Dict(:orient => "vertical"))
    end
    callback = js"""
        function(event) {
            const value = event.srcElement.valueAsNumber
            $(slider.value).notify(value);
        }
    """
    callback_kw = if slider.update_while_dragging[]
        (; oninput = callback)
    else
        (; onchange = callback)
    end


    slider_input = DOM.input(;
        type = "range",
        min = "$(min_val)",
        max = "$(max_val)",
        step = "$(step_val)",
        value = "$(initial_value)",
        style = input_styles,
        callback_kw...,
        vertical_attrs...
    )
    value_from_index = map(slider.selected_index) do idx
        return slider.range[][idx]
    end
    update_val_js = js"""
        $(value_from_index).on(x=> {
            const sliderInput = $(slider_input);
            sliderInput.value = x;
        });
    """

    slider_div = DOM.div(
        slider_input,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(slider_div, slider)
    return DOM.div(FONT_STYLE, slider_div, jss, update_val_js)
end

function replace_widget!(menu::Makie.Menu)
    Makie.hide!(menu)
    scene = Makie.rootparent(menu.blockscene)
    initial_selection = menu.selection[]
    initial_selection_idx = menu.i_selected[]
    options = menu.options[]

    # Extract Makie styling attributes
    cell_color_inactive = menu.cell_color_inactive_even[]
    cell_color_hover = menu.cell_color_hover[]
    cell_color_active = menu.cell_color_active[]
    selection_cell_color_inactive = menu.selection_cell_color_inactive[]
    text_color = menu.textcolor[]
    text_size = menu.fontsize[]
    text_padding = menu.textpadding[]
    # Create custom dropdown items
    dropdown_items = []
    option_style = Styles(
        CSS(
            "background-color" => cell_color_inactive,
            "color" => text_color,
            "font-size" => "calc(var(--winscale) * $(text_size) * 1px)",
            "padding" => "calc(var(--winscale) * $(text_padding[1]) * 1px) calc(var(--winscale) * $(text_padding[2]) * 1px) calc(var(--winscale) * $(text_padding[3]) * 1px) calc(var(--winscale) * $(text_padding[4]) * 1px)",
            "cursor" => "pointer",
        ),
        CSS(":hover", "background-color" => cell_color_hover),
        CSS(".selected", "background-color" => cell_color_active),
    )
    for (i, option) in enumerate(options)
        label_text = Makie.optionlabel(option)
        is_selected = (i == initial_selection_idx)

        push!(
            dropdown_items, DOM.div(
                label_text,
                dataValue = i,
                style = option_style,
            )
        )
    end

    # Current selection display
    current_label = Makie.optionlabel(initial_selection)
    dropdown_style = Styles(
        CSS(
            "width" => "100%",
            "height" => "100%",
            "background-color" => selection_cell_color_inactive,
            "color" => text_color,
            "font-size" => "calc(var(--winscale) * $(text_size) * 1px)",
            "cursor" => "pointer",
            "outline" => "none",
            "user-select" => "none",
            "box-sizing" => "border-box",
            "display" => "flex",
            "align-items" => "center",
            "justify-content" => "flex-start",
            "padding" => "calc(var(--winscale) * $(text_padding[1]) * 1px) calc(var(--winscale) * $(text_padding[2]) * 1px) calc(var(--winscale) * $(text_padding[3]) * 1px) calc(var(--winscale) * $(text_padding[4]) * 1px)",
        ),
        CSS(":hover", "background-color" => cell_color_hover),
    )
    dropdown_display = DOM.div(
        current_label,
        class = "dropdown-display",
        style = dropdown_style
    )

    # Dropdown list container
    dropdown_list = DOM.div(
        dropdown_items...,
        class = "dropdown-list",
        style = Styles(
            "position" => "absolute",
            "left" => "0",
            "right" => "0",
            "background-color" => "red",
            "display" => "none",
            "z-index" => "1000",
            "max-height" => "500px",
            "overflow-y" => "auto",
        )
    )

    select_element = DOM.div(
        dropdown_display,
        dropdown_list,
        style = Styles(
            "position" => "relative",
            "width" => "100%",
            "height" => "100%",
            "margin" => "0px",
            "padding" => "0px",
        )
    )

    # JavaScript for dropdown functionality
    dropdown_js = js"""
    const dropdown = $(select_element);
    const display = dropdown.querySelector('.dropdown-display');
    const list = dropdown.querySelector('.dropdown-list');
    const items = list.querySelectorAll('[data-value]');

    // Toggle dropdown
    display.onclick = function() {
        if (list.style.display === 'none' || list.style.display === '')  {
            // Check available space and position dropdown
            const dropdownRect = dropdown.getBoundingClientRect();
            const listHeight = 400; // max-height
            const spaceBelow = window.innerHeight - dropdownRect.bottom;
            const spaceAbove = dropdownRect.top;

            if (spaceBelow < listHeight && spaceAbove > spaceBelow) {
                // Open upward
                list.style.top = 'auto';
                list.style.bottom = '100%';
            } else {
                // Open downward (default)
                list.style.top = '100%';
                list.style.bottom = 'auto';
            }
            list.style.display = 'block';
        } else {
            list.style.display = 'none';
        }
    };

    function update_background() {
        const selected_index = $(menu.i_selected).value;
        items.forEach((item, index) => {
            if (index + 1 === selected_index) {
                item.classList.add('selected');
            } else {
                item.classList.remove('selected');
            }
        });
    }

    // Handle item selection
    items.forEach(item => {
        item.onclick = function() {
            const selected_index = parseInt(this.dataset.value);
            $(menu.i_selected).notify(selected_index);
            display.textContent = this.textContent;
            list.style.display = 'none';
            // Update active styling
            update_background();
        };
    });
    update_background()
    // Close dropdown when clicking outside
    document.addEventListener('click', function(e) {
        if (!dropdown.contains(e.target)) {
            list.style.display = 'none';
        }
    });
    """

    menu_div = DOM.div(
        select_element,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(menu_div, menu)
    return DOM.div(FONT_STYLE, menu_div, jss, dropdown_js)
end

function replace_widget!(textbox::Makie.Textbox)
    Makie.hide!(textbox)
    scene = Makie.rootparent(textbox.blockscene)
    initial_value = textbox.displayed_string[]
    validator = textbox.validator[]

    # Extract Makie styling attributes
    text_padding = textbox.textpadding[]
    fontsize = textbox.fontsize[]
    textcolor = textbox.textcolor[]
    boxcolor = textbox.boxcolor[]
    boxcolor_hover = textbox.boxcolor_hover[]
    boxcolor_focused = textbox.boxcolor_focused[]
    bordercolor = Bonito.convert_css_attribute(textbox.bordercolor[])
    bordercolor_hover = textbox.bordercolor_hover[]
    bordercolor_focused = textbox.bordercolor_focused[]
    borderwidth = textbox.borderwidth[]
    cornerradius = textbox.cornerradius[]

    # Determine input type based on validator
    input_type = "text"

    # Input styled directly - no padding (which causes clipping due to browser's
    # `overflow: clip !important` for text <input>), instead use text-indent for horizontal offset
    input_styles = Styles(
        CSS(
            "width" => "100%",
            "height" => "100%",
            "box-sizing" => "border-box",
            "font-family" => "inherit",
            "font-size" => "calc(var(--winscale) * $(fontsize) * 1px)",
            "color" => textcolor,
            "border" => "calc(var(--winscale) * $(borderwidth) * 1px) solid $(bordercolor)",
            "border-radius" => "calc(var(--winscale) * $(cornerradius) * 1px)",
            "background-color" => boxcolor,
            "padding" => "0",
            "outline" => "none",
            "transition" => "border-color 0.2s, background-color 0.2s",
            # Use text-indent for horizontal padding (doesn't affect content box)
            "text-indent" => "calc(var(--winscale) * $(text_padding[4]) * 1px)",
        ),
        CSS(
            ":hover",
            "border-color" => bordercolor_hover,
            "background-color" => boxcolor_hover,
        ),
        CSS(
            ":focus",
            "border-color" => bordercolor_focused,
            "background-color" => boxcolor_focused,
        ),
    )

    # Add number-specific attributes for numeric validators
    input_attrs = Dict(
        :type => input_type,
        :value => string(initial_value),
        :placeholder => textbox.placeholder[],
    )
    if input_type == "number"
        input_attrs[:step] = "any"  # Allow any decimal precision
    end

    textbox_input = DOM.input(;
        input_attrs...,
        style = input_styles,
        value = textbox.displayed_string,
        onchange = js"""
            function(event) {
                let value = event.target.value;
                // Handle validation for numeric types
                if ($(input_type) === "number") {
                    const numValue = parseFloat(value);
                    if (!isNaN(numValue)) {
                        $(textbox.displayed_string).notify(value);
                        $(textbox.stored_string).notify(value);
                    }
                } else {
                    $(textbox.displayed_string).notify(value);
                    $(textbox.stored_string).notify(value);
                }
            }
        """,
        oninput = js"""
            function(event) {
                const value = event.target.value;
                $(textbox.displayed_string).notify(value);
            }
        """
    )

    textbox_div = DOM.div(
        textbox_input,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(textbox_div, textbox)
    return DOM.div(FONT_STYLE, textbox_div, jss)
end

function replace_widget!(button::Makie.Button)
    Makie.hide!(button)

    # Extract Makie styling attributes
    button_text = button.label[]
    fontsize = button.fontsize[]
    # Not sure why the button needs extra scaling for padding
    padding = round.(Int, button.padding[] ./ 1.5)
    cornerradius = button.cornerradius[]
    strokewidth = button.strokewidth[]
    strokecolor = button.strokecolor[]
    buttoncolor = button.buttoncolor[]
    buttoncolor_hover = button.buttoncolor_hover[]
    buttoncolor_active = button.buttoncolor_active[]
    labelcolor = button.labelcolor[]
    labelcolor_hover = button.labelcolor_hover[]
    labelcolor_active = button.labelcolor_active[]

    button_element = DOM.button(
        button_text,
        style = Styles(
            CSS(
                "width" => "100%",
                "height" => "100%",
                "font-family" => "inherit",
                "font-size" => "calc(var(--winscale) * $(fontsize) * 1px)",
                "padding" => "calc(var(--winscale) * $(padding[1]) * 1px) calc(var(--winscale) * $(padding[2]) * 1px) calc(var(--winscale) * $(padding[3]) * 1px) calc(var(--winscale) * $(padding[4]) * 1px)",
                "border" => "calc(var(--winscale) * $(strokewidth) * 1px) solid $(strokecolor)",
                "border-radius" => "calc(var(--winscale) * $(cornerradius) * 1px)",
                "background-color" => buttoncolor,
                "color" => labelcolor,
                "cursor" => "pointer",
                "outline" => "none",
                "transition" => "background-color 0.2s, color 0.2s",
            ),
            CSS(
                ":hover",
                "background-color" => buttoncolor_hover,
                "color" => labelcolor_hover,
            ),
            CSS(
                ":active",
                "background-color" => buttoncolor_active,
                "color" => labelcolor_active,
            ),
        ),
        onclick = js"""
            function(event) {
                console.log("Button clicked");
                $(button.clicks).notify($(button.clicks).value + 1);
            }
        """
    )
    button_div = DOM.div(
        button_element,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(button_div, button)
    return DOM.div(FONT_STYLE, button_div, jss)
end

function replace_widget!(checkbox::Makie.Checkbox)
    Makie.hide!(checkbox)

    # Extract Makie styling attributes
    size = checkbox.size[]
    checkmarksize = checkbox.checkmarksize[]
    roundness = checkbox.roundness[]
    checkboxstrokewidth = checkbox.checkboxstrokewidth[]
    checkboxcolor_checked = checkbox.checkboxcolor_checked[]
    checkboxcolor_unchecked = checkbox.checkboxcolor_unchecked[]
    checkboxstrokecolor_checked = checkbox.checkboxstrokecolor_checked[]
    checkmarkcolor_checked = checkbox.checkmarkcolor_checked[]

    checkbox_element = DOM.input(
        type = "checkbox",
        checked = checkbox.checked[],
        style = Styles(
            CSS(
                "width" => "calc(var(--winscale) * $(size + 2checkboxstrokewidth) * 1px)",
                "height" => "calc(var(--winscale) * $(size + 2checkboxstrokewidth) * 1px)",
                "flex-shrink" => "0",
                "appearance" => "none",
                "-webkit-appearance" => "none",
                "-moz-appearance" => "none",
                "cursor" => "pointer",
                "border-style" => "solid",
                "border-width" => "calc(var(--winscale) * $(checkboxstrokewidth) * 1px)",
                "border-color" => checkboxcolor_checked,
                "background-color" => checkboxcolor_unchecked,
                "outline" => "none",
                "position" => "relative",
                "transition" => "background-color 0.2s, border-color 0.2s",
            ),
            CSS(
                ":checked",
                "background-color" => checkboxcolor_checked,
                "border-color" => checkboxstrokecolor_checked,
            ),
            # Create checkmark using ::after pseudo-element
            CSS(
                "::after",
                "content" => "\"\"",
                "position" => "absolute",
                "display" => "none",
                "left" => "50%",
                "top" => "40%",
                "width" => "calc(var(--winscale) * $(size * checkmarksize * 0.3) * 1px)",
                "height" => "calc(var(--winscale) * $(size * checkmarksize * 0.6) * 1px)",
                "border" => "solid $(checkmarkcolor_checked)",
                "border-width" => "0 calc(var(--winscale) * $(checkboxstrokewidth * 1.5) * 1px) calc(var(--winscale) * $(checkboxstrokewidth * 1.5) * 1px) 0",
                "transform" => "translate(-50%, -50%) rotate(45deg)",
            ),
            CSS(
                ":checked::after",
                "display" => "block",
            ),
        ),
        onchange = js"""
            function(event) {
                const isChecked = event.target.checked;
                $(checkbox.checked).notify(isChecked);
            }
        """
    )

    checkbox_div = DOM.div(
        checkbox_element,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(checkbox_div, checkbox)
    return DOM.div(FONT_STYLE, checkbox_div, jss)
end

function replace_widget!(toggle::Makie.Toggle)
    Makie.hide!(toggle)

    # Extract Makie styling attributes
    length = toggle.length[]
    markersize = toggle.markersize[]
    framecolor_inactive = toggle.framecolor_inactive[]
    framecolor_active = toggle.framecolor_active[]
    buttoncolor = toggle.buttoncolor[]
    rimfraction = toggle.rimfraction[]

    # Calculate dimensions
    track_height = markersize
    track_width = length
    button_size = markersize * (1 - rimfraction)
    border_width = markersize * rimfraction / 2

    toggle_input = DOM.input(
        type = "checkbox",
        checked = toggle.active[],
        style = Styles(
            CSS(
                "appearance" => "none",
                "-webkit-appearance" => "none",
                "-moz-appearance" => "none",
                "width" => "calc(var(--winscale) * $(track_width) * 1px)",
                "height" => "calc(var(--winscale) * $(track_height) * 1px)",
                "min-width" => "calc(var(--winscale) * $(track_width) * 1px)",
                "min-height" => "calc(var(--winscale) * $(track_height) * 1px)",
                "flex-shrink" => "0",
                "cursor" => "pointer",
                "background-color" => framecolor_inactive,
                "border-radius" => "calc(var(--winscale) * $(track_height / 2) * 1px)",
                "position" => "relative",
                "outline" => "none",
                "box-sizing" => "border-box",
                "transition" => "background-color 0.15s",
            ),
            CSS(
                ":checked",
                "background-color" => framecolor_active,
            ),
            # Create toggle button using ::before pseudo-element
            CSS(
                "::before",
                "content" => "\"\"",
                "position" => "absolute",
                "width" => "calc(var(--winscale) * $(button_size) * 1px)",
                "height" => "calc(var(--winscale) * $(button_size) * 1px)",
                "border-radius" => "50%",
                "background-color" => buttoncolor,
                "left" => "calc(var(--winscale) * $(border_width) * 1px)",
                "top" => "50%",
                "transform" => "translateY(-50%)",
                "transition" => "left 0.15s",
            ),
            CSS(
                ":checked::before",
                "left" => "calc(var(--winscale) * $(track_width - button_size - border_width) * 1px)",
            ),
        ),
        onchange = js"""
            function(event) {
                const isActive = event.target.checked;
                $(toggle.active).notify(isActive);
            }
        """
    )

    toggle_div = DOM.div(
        toggle_input,
        style = WIDGET_CONTAINER_STYLES
    )
    jss = resize_parent(toggle_div, toggle)
    return DOM.div(FONT_STYLE, toggle_div, jss)
end

replace_widget!(x::Any) = nothing # not implemented
function replace_widget!(fig::Figure)
    return DOM.div(map(replace_widget!, fig.content))
end

using PrecompileTools

macro compile(block)
    return quote
        let
            figlike = $(esc(block))
            # We don't do something like colorbuffer(fig)
            # since we can't guarantee that the user has a browser setup
            # while precompiling
            # So we just do all parts of the stack we can do without browser
            session = Session()
            app = App(() -> DOM.div(figlike))
            dom = Bonito.session_dom(session, app)
            show(IOBuffer(), dom)
            Makie.second_resolve(figlike, :wgl_renderobject)
            close(session)
            yield()
            return nothing
        end
    end
end

let
    @compile_workload begin
        WGLMakie.activate!()
        include(Makie.SHARED_PRECOMPILE_PATH)
        # Cleanup globals to avoid serializing stale state (servers, sessions, fonts, figures, tasks)
        # Note: __init__ doesn't run during precompilation, so we must always clean up here
        Bonito.cleanup_globals()
        Makie.cleanup_globals()
        nothing
    end
end

using Electron, WGLMakie, Bonito, Test


@testset "HTML Widgets" begin
    WGLMakie.activate!(use_html_widgets = true)
    @testset "Slider - basic horizontal" begin
        fig = Figure()
        ax = Axis(fig[1, 1])
        sl = Makie.Slider(fig[2, 1], range = 0:0.01:10, startvalue = 3)

        point = lift(sl.value) do x
            Point2f(x, 5)
        end
        scatter!(point, color = :red, markersize = 20)
        limits!(ax, 0, 10, 0, 10)

        app = App(fig)
        display(edisplay, app)

        # Test that slider renders as HTML range input
        slider_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=range]");
                return {
                    value: parseFloat(node.value),
                    min: parseFloat(node.min),
                    max: parseFloat(node.max),
                    step: parseFloat(node.step),
                    exists: node !== null
                }
            })()"""
        )

        @test slider_props["exists"] == true
        @test slider_props["value"] ≈ 3.0
        @test slider_props["min"] ≈ 0.0
        @test slider_props["max"] ≈ 10.0
        @test slider_props["step"] ≈ 0.01

        # Test interaction - change value via JS
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=range]");
                node.value = 7.5;
                node.dispatchEvent(new Event('input', { bubbles: true }));
                node.dispatchEvent(new Event('change', { bubbles: true }));
            })()"""
        )
        @test sl.value[] ≈ 7.5
    end

    @testset "Slider - vertical and update_while_dragging" begin
        fig = Figure()
        ax = Axis(fig[1, 1])
        sl_x = Makie.Slider(fig[2, 1], range = 0:0.01:10, startvalue = 3, update_while_dragging = false)
        sl_y = Makie.Slider(fig[1, 2], range = 0:0.01:10, horizontal = false, startvalue = 6)

        point = lift(sl_x.value, sl_y.value) do x, y
            Point2f(x, y)
        end
        scatter!(point, color = :red, markersize = 20)
        limits!(ax, 0, 10, 0, 10)

        app = App(fig)
        display(edisplay, app)

        # Test both sliders exist
        sliders = evaljs_value(
            app.session[], js"""(() => {
                const nodes = document.querySelectorAll("input[type=range]");
                return {
                    count: nodes.length,
                    values: Array.from(nodes).map(n => parseFloat(n.value))
                }
            })()"""
        )

        @test sliders["count"] == 2
        @test sliders["values"][1] ≈ 3.0
        @test sliders["values"][2] ≈ 6.0

        # Test changing first slider
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelectorAll("input[type=range]")[0];
                node.value = 2;
                node.dispatchEvent(new Event('input', { bubbles: true }));
                node.dispatchEvent(new Event('change', { bubbles: true }));
            })()"""
        )

        @test sl_x.value[] ≈ 2.0
    end

    @testset "Button - click counting" begin
        fig = Figure()
        btn = Makie.Button(fig[1, 1], label = "Click Me!")

        click_count = Observable(0)
        on(btn.clicks) do n
            click_count[] = n
        end

        app = App(fig)
        display(edisplay, app)

        # Test that button renders as HTML button
        button_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("button");
                return {
                    exists: node !== null,
                    text: node.textContent.trim()
                }
            })()"""
        )

        @test button_props["exists"] == true
        @test button_props["text"] == "Click Me!"

        # Test clicking the button
        initial_clicks = btn.clicks[]
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("button");
                node.click();
            })()"""
        )

        @test btn.clicks[] == initial_clicks + 1

        # Click multiple times
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("button");
                node.click();
                node.click();
            })()"""
        )

        @test btn.clicks[] == initial_clicks + 3
    end

    @testset "Menu - string options" begin
        fig = Figure()
        menu = Makie.Menu(fig[1, 1], options = ["Option A", "Option B", "Option C"], default = "Option B")

        app = App(fig)
        display(edisplay, app)

        # Test that menu renders as custom dropdown with divs
        menu_props = evaljs_value(
            app.session[], js"""(() => {
                const dropdown = document.querySelector('.dropdown-display');
                const list = document.querySelector('.dropdown-list');
                const items = document.querySelectorAll('[data-value]');

                return {
                    exists: dropdown !== null,
                    displayText: dropdown ? dropdown.textContent.trim() : "",
                    itemCount: items.length,
                    itemTexts: Array.from(items).map(item => item.textContent.trim())
                }
            })()"""
        )

        @test menu_props["exists"] == true
        @test menu_props["displayText"] == "Option B"
        @test menu_props["itemCount"] == 3
        @test menu_props["itemTexts"] == ["Option A", "Option B", "Option C"]
        @test menu.selection[] == "Option B"
        @test menu.i_selected[] == 2

        # Test selecting a different option
        evaljs_value(
            app.session[], js"""(() => {
                const items = document.querySelectorAll('[data-value]');
                items[2].click(); // Select "Option C" (0-indexed, so index 2)
            })()"""
        )

        @test menu.selection[] == "Option C"
        @test menu.i_selected[] == 3

        # Test selecting first option
        evaljs_value(
            app.session[], js"""(() => {
                const items = document.querySelectorAll('[data-value]');
                items[0].click(); // Select "Option A"
            })()"""
        )

        @test menu.selection[] == "Option A"
        @test menu.i_selected[] == 1
    end

    @testset "Menu - function values" begin
        fig = Figure()
        ax = Axis(fig[1, 1])

        funcs = [sin, cos, tan, sqrt]
        menu = Makie.Menu(
            fig[2, 1],
            options = zip(["Sine", "Cosine", "Tangent", "Square Root"], funcs),
            default = "Cosine"
        )

        # Plot based on selected function
        xs = 0:0.1:5
        ys = lift(menu.selection) do f
            f.(xs)
        end

        lines!(ax, xs, ys)

        app = App(fig)
        display(edisplay, app)

        # Verify initial state
        @test menu.selection[] == cos
        @test menu.i_selected[] == 2

        # Select "Sine" function
        evaljs_value(
            app.session[], js"""(() => {
                const items = document.querySelectorAll('[data-value]');
                items[0].click(); // Select first option (Sine)
            })()"""
        )

        @test menu.selection[] == sin
        @test menu.i_selected[] == 1

        # Select "Square Root" function
        evaljs_value(
            app.session[], js"""(() => {
                const items = document.querySelectorAll('[data-value]');
                items[3].click(); // Select fourth option (Square Root)
            })()"""
        )

        @test menu.selection[] == sqrt
        @test menu.i_selected[] == 4
    end

    @testset "Textbox - text entry" begin
        fig = Figure()
        textbox = Makie.Textbox(fig[1, 1], placeholder = "Enter text...")

        app = App(fig)
        display(edisplay, app)

        # Test that textbox renders as HTML input
        textbox_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=text]");
                return {
                    exists: node !== null,
                    type: node ? node.type : "",
                    value: node ? node.value : "",
                    placeholder: node ? node.placeholder : ""
                }
            })()"""
        )

        @test textbox_props["exists"] == true
        @test textbox_props["type"] == "text"
        # Empty input shows the placeholder via the native HTML attribute
        @test textbox_props["value"] == ""
        @test textbox_props["placeholder"] == "Enter text..."

        # Test entering text
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=text]");
                node.value = "Hello World";
                node.dispatchEvent(new Event('input', { bubbles: true }));
                node.dispatchEvent(new Event('change', { bubbles: true }));
            })()"""
        )

        @test textbox.displayed_string[] == "Hello World"
        @test textbox.stored_string[] == "Hello World"
    end

    @testset "Textbox - numeric validator" begin
        fig = Figure()
        textbox = Makie.Textbox(fig[1, 1], validator = Float64, stored_string = "3.14")

        app = App(fig)
        display(edisplay, app)

        # Test that textbox renders as HTML number input
        textbox_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input");
                return {
                    exists: node !== null,
                    type: node ? node.type : "",
                    value: node ? node.value : ""
                }
            })()"""
        )

        @test textbox_props["exists"] == true
        @test textbox_props["value"] == "3.14"

        # Test entering a new number
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input");
                node.value = "2.71";
                node.dispatchEvent(new Event('input', { bubbles: true }));
                node.dispatchEvent(new Event('change', { bubbles: true }));
            })()"""
        )
        @test textbox.displayed_string[] == "2.71"
        @test textbox.stored_string[] == "2.71"
    end

    @testset "Checkbox - toggle state" begin
        fig = Figure()
        checkbox = Makie.Checkbox(fig[1, 1])

        app = App(fig)
        display(edisplay, app)

        # Test that checkbox renders as HTML checkbox input
        checkbox_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                return {
                    exists: node !== null,
                    checked: node ? node.checked : false
                }
            })()"""
        )

        @test checkbox_props["exists"] == true
        @test checkbox_props["checked"] == false
        @test checkbox.checked[] == false

        # Test checking the checkbox
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                node.click();
            })()"""
        )

        @test checkbox.checked[] == true

        # Test unchecking the checkbox
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                node.click();
            })()"""
        )

        @test checkbox.checked[] == false
    end

    @testset "Checkbox - initial checked state" begin
        fig = Figure()
        checkbox = Makie.Checkbox(fig[1, 1], checked = false)

        app = App(fig)
        display(edisplay, app)

        # Test that checkbox is initially checked
        checkbox_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                return {
                    checked: node ? node.checked : false
                }
            })()"""
        )

        @test checkbox_props["checked"] == false
        @test checkbox.checked[] == false
    end

    @testset "Toggle - toggle state" begin
        fig = Figure()
        toggle = Makie.Toggle(fig[1, 1])

        app = App(fig)
        display(edisplay, app)

        # Test that toggle renders as HTML checkbox input
        toggle_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                return {
                    exists: node !== null,
                    checked: node ? node.checked : false
                }
            })()"""
        )

        @test toggle_props["exists"] == true
        @test toggle_props["checked"] == false
        @test toggle.active[] == false

        # Test activating the toggle
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                node.click();
            })()"""
        )

        @test toggle.active[] == true

        # Test deactivating the toggle
        evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                node.click();
            })()"""
        )

        @test toggle.active[] == false
    end

    @testset "Toggle - initial active state" begin
        fig = Figure()
        toggle = Makie.Toggle(fig[1, 1], active = true)

        app = App(fig)
        display(edisplay, app)

        # Test that toggle is initially active
        toggle_props = evaljs_value(
            app.session[], js"""(() => {
                const node = document.querySelector("input[type=checkbox]");
                return {
                    checked: node ? node.checked : false
                }
            })()"""
        )

        @test toggle_props["checked"] == true
        @test toggle.active[] == true
    end

    @testset "Widget interactions - Slider + Button" begin
        fig = Figure()
        ax = Axis(fig[1, 1], title = "Interactive Plot")

        # Create slider to control x position
        sl_x = Makie.Slider(fig[2, 1], range = 0:0.1:10, startvalue = 5)

        # Create button to add random points
        btn = Makie.Button(fig[3, 1], label = "Add Point")

        # Points to plot
        points = Observable(Point2f[])

        # When button is clicked, add a point at slider position
        on(btn.clicks) do n
            x = sl_x.value[]
            y = rand() * 10
            push!(points[], Point2f(x, y))
            notify(points)
        end

        scatter!(ax, points, color = :blue, markersize = 15)
        limits!(ax, 0, 10, 0, 10)

        app = App(fig)
        display(edisplay, app)

        # Verify widgets exist
        widgets_exist = evaljs_value(
            app.session[], js"""(() => {
                return {
                    slider: document.querySelector("input[type=range]") !== null,
                    button: document.querySelector("button") !== null
                }
            })()"""
        )

        @test widgets_exist["slider"] == true
        @test widgets_exist["button"] == true

        initial_count = length(points[])

        # Move slider to position 7
        evaljs_value(
            app.session[], js"""(() => {
                const slider = document.querySelector("input[type=range]");
                slider.value = 7.0;
                slider.dispatchEvent(new Event('input', { bubbles: true }));
                slider.dispatchEvent(new Event('change', { bubbles: true }));
            })()"""
        )

        @test sl_x.value[] ≈ 7.0

        # Click button to add a point
        evaljs_value(
            app.session[], js"""(() => {
                const button = document.querySelector("button");
                button.click();
            })()"""
        )

        @test length(points[]) == initial_count + 1
        @test points[][end][1] ≈ 7.0  # X position should be slider value
    end
end

using ShaderAbstractions: InstancedProgram, Program
using Makie: Key, plotkey
using Colors: N0f8


tlength(T) = length(T)
tlength(::Type{<:Real}) = 1

serialize_three(::Nothing) = false
serialize_three(val::Number) = val
serialize_three(val::Vec2f) = convert(Vector{Float32}, val)
serialize_three(val::Vec3f) = convert(Vector{Float32}, val)
serialize_three(val::Vec4f) = convert(Vector{Float32}, val)
serialize_three(val::Quaternion) = convert(Vector{Float32}, collect(val.data))
serialize_three(val::RGB) = Float32[red(val), green(val), blue(val)]
serialize_three(val::RGBA) = Float32[red(val), green(val), blue(val), alpha(val)]
serialize_three(val::Mat4f) = collect(vec(val))
serialize_three(val::Mat3) = collect(vec(val))

function serialize_three(array::AbstractArray)
    return serialize_three(flatten_buffer(array))
end

function serialize_three(array::Buffer)
    return serialize_three(flatten_buffer(array))
end
function serialize_three(array::AbstractVector{T}) where {T <: OffsetInteger}
    return serialize_three(map(GeometryBasics.raw, array))
end
function serialize_three(array::AbstractArray{T}) where {T <: Union{N0f8, UInt8, Int32, UInt32, Float32, Float16, Float64}}
    return vec(convert(Array, array))
end

three_format(::Type{<:Integer}) = "RedIntegerFormat"
three_format(::Type{<:Real}) = "RedFormat"
three_format(::Type{<:RGB}) = "RGBFormat"
three_format(::Type{<:RGBA}) = "RGBAFormat"

three_format(::Type{<:Makie.VecTypes{1}}) = "RedFormat"
three_format(::Type{<:Makie.VecTypes{2}}) = "RGFormat"
three_format(::Type{<:Makie.VecTypes{3}}) = "RGBFormat"
three_format(::Type{<:Makie.VecTypes{4}}) = "RGBAFormat"

three_type(::Type{Float16}) = "FloatType"
three_type(::Type{Float32}) = "FloatType"
three_type(::Type{N0f8}) = "UnsignedByteType"
three_type(::Type{UInt8}) = "UnsignedByteType"

function three_filter(sym::Symbol)
    sym === :linear && return "LinearFilter"
    sym === :nearest && return "NearestFilter"
    sym == :nearest_mipmap_nearest && return "NearestMipmapNearestFilter"
    sym == :nearest_mipmap_linear  && return "NearestMipmapLinearFilter"
    sym == :linear_mipmap_nearest  && return "LinearMipmapNearestFilter"
    sym == :linear_mipmap_linear   && return "LinearMipmapLinearFilter"
    error("Unknown filter mode '$sym'")
end

function three_repeat(s::Symbol)
    s === :clamp_to_edge && return "ClampToEdgeWrapping"
    s === :mirrored_repeat && return "MirroredRepeatWrapping"
    s === :repeat && return "RepeatWrapping"
    error("Unknown repeat mode '$s'")
end

"""
    NoDataTextureAtlas(texture_atlas_size)

Optimization to just send the texture atlas one time to JS and then look it up from there in wglmakie.js,
instead of uploading this texture 10x in every plot.
"""
struct NoDataTextureAtlas <: ShaderAbstractions.AbstractSampler{Float16, 2}
    dims::NTuple{2, Int}
end
Base.size(x::NoDataTextureAtlas) = x.dims
Base.show(io::IO, ::NoDataTextureAtlas) = print(io, "NoDataTextureAtlas()")

function serialize_three(fta::NoDataTextureAtlas)
    tex = Dict(
        :type => "Sampler", :data => "texture_atlas",
        :size => [fta.dims...], :three_format => three_format(Float16),
        :three_type => three_type(Float16),
        :minFilter => three_filter(:linear),
        :magFilter => three_filter(:linear),
        :wrapS => "RepeatWrapping",
        :anisotropy => 16.0f0
    )
    tex[:wrapT] = "RepeatWrapping"
    return tex
end

function serialize_three(color::Sampler{T, N}) where {T, N}
    tex = Dict(
        :type => "Sampler",
        :data => serialize_three(color.data),
        :size => Int32[size(color.data)...],
        :three_format => three_format(T),
        :three_type => three_type(eltype(T)),
        :minFilter => three_filter(color.minfilter),
        :magFilter => three_filter(color.magfilter),
        :wrapS => three_repeat(color.repeat[1]),
        :mipmap => color.mipmap,
        :anisotropy => color.anisotropic
    )
    if N > 1
        tex[:wrapT] = three_repeat(color.repeat[2])
    end
    if N > 2
        tex[:wrapR] = three_repeat(color.repeat[3])
    end
    return tex
end

function serialize_uniforms(dict::Dict)
    result = Dict{Symbol, Any}()
    for (k, v) in dict
        # we don't send observables and instead use
        # uniform_updater(dict)
        result[k] = serialize_three(v)
    end
    return result
end

serialize_three(x::Dict) = x

"""
    flatten_buffer(array::AbstractArray)

Flattens `array` array to be a 1D Vector of Float32 / UInt8.
If presented with AbstractArray{<: Colorant/Tuple/SVector}, it will flatten those
to their element type.
"""
function flatten_buffer(array::AbstractArray{<:Number})
    return array
end
function flatten_buffer(array::AbstractArray{<:AbstractFloat})
    return convert(Array{Float32}, array)
end
function flatten_buffer(array::Buffer)
    return flatten_buffer(getfield(array, :data))
end

function flatten_buffer(array::AbstractArray{T}) where {T <: N0f8}
    return collect(reinterpret(UInt8, array))
end

function flatten_buffer(array::AbstractArray{T}) where {T}
    return flatten_buffer(collect(reinterpret(eltype(T), array)))
end

const ALL_SHADERS = Dict{String, String}()
function lasset(paths...)
    return get!(ALL_SHADERS, joinpath(paths...)) do
        read(joinpath(@__DIR__, "..", "assets", paths...), String)
    end
end


function ShaderAbstractions.type_string(
        ::ShaderAbstractions.AbstractContext,
        ::Type{<:Makie.Quaternion}
    )
    return "vec4"
end

function ShaderAbstractions.convert_uniform(
        ::ShaderAbstractions.AbstractContext,
        t::Quaternion
    )
    return convert(Quaternion, t)
end

function serialize_buffer_attribute(buffer::AbstractVector{T}) where {T}
    return Dict(:flat => serialize_three(buffer), :type_length => tlength(T))
end


reinterpret_faces(p, faces::AbstractVector) = collect(reinterpret(UInt32, decompose(GLTriangleFace, faces)))

function reinterpret_faces(@nospecialize(plot), faces::Buffer)
    return reinterpret_faces(plot, ShaderAbstractions.data(faces))
end

function serialize_scene(scene::Scene)

    hexcolor(c) = "#" * hex(Colors.color(to_color(c)))
    pixel_area = lift(area -> Int32[minimum(area)..., widths(area)...], scene, viewport(scene); ignore_equal_values = true)
    cam_controls = cameracontrols(scene)
    cam3d_state = if cam_controls isa Camera3D
        fields = (:lookat, :upvector, :eyeposition, :fov, :near, :far)
        dict = Dict((f => lift(x -> serialize_three(Float32.(x)), scene, getfield(cam_controls, f)) for f in fields))
        dict[:resolution] = lift(res -> Int32[res...], scene, scene.camera.resolution; ignore_equal_values = true)
        dict
    else
        nothing
    end

    children = map(child -> serialize_scene(child), scene.children)

    light_dir = Observable(serialize_three(Vec3f(1)), ignore_equal_values = true)
    cam_rel = Observable(serialize_three(false), ignore_equal_values = true)
    ambient = Observable(serialize_three(RGBf(0, 0, 1)), ignore_equal_values = true)
    light_color = Observable(serialize_three(RGBf(1, 0, 0)), ignore_equal_values = true)

    on(scene.compute.onchange, update = true) do _
        ambient[] = serialize_three(scene.compute[:ambient_color][])
        light_color[] = serialize_three(scene.compute[:dirlight_color][])
        light_dir[] = serialize_three(scene.compute[:dirlight_direction][])
        cam_rel[] = serialize_three(scene.compute[:dirlight_cam_relative][])
        return
    end

    serialized = Dict(
        :viewport => pixel_area,
        :backgroundcolor => lift(hexcolor, scene, scene.backgroundcolor; ignore_equal_values = true),
        :backgroundcolor_alpha => lift(Colors.alpha, scene, scene.backgroundcolor; ignore_equal_values = true),
        :clearscene => scene.clear,
        :camera => serialize_camera(scene),
        :light_direction => light_dir,
        :camera_relative_light => cam_rel,
        :ambient => ambient,
        :light_color => light_color,
        :plots => serialize_plots(scene, scene.plots),
        :cam3d_state => cam3d_state,
        :visible => scene.visible,
        :uuid => js_uuid(scene),
        :children => children
    )
    return serialized
end

function serialize_plots(scene::Scene, plots::Vector{Plot}, result = [])
    for plot in plots
        # if no plots inserted, this truly is an atomic
        if Makie.is_atomic_plot(plot)
            plot_data = serialize_three(scene, plot)
            plot_data[:uuid] = js_uuid(plot)
            push!(result, plot_data)
        end
        if !isempty(plot.plots)
            serialize_plots(scene, plot.plots, result)
        end
    end
    return result
end

function flat_m4f(x::AbstractArray)
    result = Vector{Float32}(undef, length(x))
    copyto!(result, Mat4f(x))
    return result
end

function serialize_camera(scene::Scene)
    cam = scene.camera
    # somehow ignore_equal_values=true is not enough,
    # so we manually check if previous values are the same
    last_view = Base.RefValue(Mat4d(I))
    last_proj = Base.RefValue(Mat4d(I))
    last_res = Base.RefValue(Vec2f(0))
    last_eyepos = Base.RefValue(Vec3f(0))
    obs = Observable([Float32[], Float32[], Int32[], Float32[]])

    onany(scene, cam.view, cam.projection, cam.resolution, cam.eyeposition; update = true) do view, proj, res, ep
        # eyeposition updates with viewmatrix, since an eyepos change will trigger
        # a view matrix change!
        if !(view ≈ last_view[] && proj ≈ last_proj[] && res ≈ last_res[] && ep ≈ last_eyepos[])
            obs[] = [flat_m4f(view), flat_m4f(proj), Int32[res...], Float32[ep...]]
        end
        last_eyepos[] = ep
        last_view[] = view
        last_proj[] = proj
        last_res[] = res
        return
    end
    return obs
end

# These tests are relevant for general Makie performance but only tested here
# because Bonito makes it easy to test. If the tests fail it is likely not
# WGLMakies fault.
# A lower number of messages maybe caused by optimizations or broken interactions.
# A higher number could come from added functionality or performance regressions.


@testset "TextBox with Menu" begin
    f = Figure()
    t1 = Textbox(f[1, 1])
    m = Menu(f[2, 1], options = string.(1:1000))
    display(edisplay, App(f))

    # trigger select
    all_messages, summary_str = Bonito.collect_messages() do
        events(f).mouseposition[] = (300, 250)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.press)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.release)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 16

    # type text
    for (char, expected) in zip(collect("test"), [2, 15, 15, 15])
        _key = getproperty(Makie.Keyboard, Symbol(char))
        all_messages, summary_str = Bonito.collect_messages() do
            events(f).keyboardbutton[] = Makie.KeyEvent(_key, Keyboard.press)
            events(f).unicode_input[] = char
            events(f).keyboardbutton[] = Makie.KeyEvent(_key, Keyboard.release)
            WGLMakie.poll_all_plots(f.scene)
        end
        @test length(all_messages) == expected
    end
end

@testset "Menu" begin
    f = Figure()
    m = Menu(f[1, 1], options = string.(1:10))
    display(edisplay, App(f))
    # open menu
    all_messages, summary_str = Bonito.collect_messages() do
        events(f).mouseposition[] = (300, 230)
        WGLMakie.poll_all_plots(f.scene)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.press)
        WGLMakie.poll_all_plots(f.scene)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.release)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 10

    # scroll items
    all_messages, summary_str = Bonito.collect_messages() do
        events(f).mouseposition[] = (300, 200)
        events(f).scroll[] = (0.0, -1.0)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 1

    # select item
    all_messages, summary_str = Bonito.collect_messages() do
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.press)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.release)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 7
end

@testset "Textbox" begin
    f = Figure()
    t1 = Textbox(f[1, 1], tellwidth = false)
    display(edisplay, App(f))

    all_messages, summary_str = Bonito.collect_messages() do
        events(f).mouseposition[] = (300, 225)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.press)
        events(f).mousebutton[] = Makie.MouseButtonEvent(Mouse.left, Mouse.release)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 11

    all_messages, summary_str = Bonito.collect_messages() do
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.t, Keyboard.press)
        events(f).unicode_input[] = 't'
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.t, Keyboard.release)
        WGLMakie.poll_all_plots(f.scene)

    end
    @test length(all_messages) == 2

    all_messages, summary_str = Bonito.collect_messages() do
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.e, Keyboard.press)
        events(f).unicode_input[] = 'e'
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.e, Keyboard.release)
        WGLMakie.poll_all_plots(f.scene)

    end
    @test length(all_messages) == 12

    all_messages, summary_str = Bonito.collect_messages() do
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.s, Keyboard.press)
        events(f).unicode_input[] = 's'
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.s, Keyboard.release)
        WGLMakie.poll_all_plots(f.scene)

    end
    @test length(all_messages) == 11

    all_messages, summary_str = Bonito.collect_messages() do
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.t, Keyboard.press)
        events(f).unicode_input[] = 't'
        events(f).keyboardbutton[] = Makie.KeyEvent(Keyboard.t, Keyboard.release)
        WGLMakie.poll_all_plots(f.scene)
    end
    @test length(all_messages) == 11

end

macro handle(accessor, body)
    obj, field = accessor.args
    key = string(field.value)
    efield = esc(field.value)
    obj = esc(obj)
    return quote
        if haskey($(obj), $(key))
            $(efield) = $(obj)[$(key)]
            $(esc(body))
            return nothing
        end
    end
end

function code_to_keyboard(code::String)
    if length(code) == 1 && isnumeric(code[1])
        return getfield(Keyboard, Symbol("_" * code))
    end
    button = lowercase(code)
    if startswith(button, "arrow")
        return getfield(Keyboard, Symbol(button[6:end]))
    end
    if startswith(button, "digit")
        return getfield(Keyboard, Symbol("_" * button[6:end]))
    end
    if startswith(button, "key")
        return getfield(Keyboard, Symbol(button[4:end]))
    end
    button = replace(button, r"(.*)left" => s"left_\1")
    button = replace(button, r"(.*)right" => s"right_\1")
    sym = Symbol(button)
    return if isdefined(Keyboard, sym)
        return getfield(Keyboard, sym)
    elseif sym === :backquote
        return Keyboard.grave_accent
    elseif sym === :pageup
        return Keyboard.page_up
    elseif sym === :pagedown
        return Keyboard.page_down
    elseif sym === :end
        return Keyboard._end
    elseif sym === :capslock
        return Keyboard.caps_lock
    elseif sym === :contextmenu
        return Keyboard.menu
    elseif sym === :left_meta
        return Keyboard.left_super
    elseif sym === :right_meta
        return Keyboard.right_super
    else
        return Keyboard.unknown
    end
end

function connect_scene_events!(screen::Screen, scene::Scene, comm::Observable)
    e = events(scene)
    on(comm) do msg
        @async try
            @handle msg.window_open begin
                e.window_open[] = window_open
            end
            @handle msg.mouseposition begin
                x, y = Float64.((mouseposition...,))
                e.mouseposition[] = (x, y)
            end
            @handle msg.mousedown begin
                # This can probably be done better from the JS side?
                state = e.mousebuttonstate
                if mousedown & 1 != 0 && !(Mouse.left in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.left, Mouse.press))
                end
                if mousedown & 2 != 0 && !(Mouse.right in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.right, Mouse.press))
                end
                if mousedown & 4 != 0 && !(Mouse.middle in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.middle, Mouse.press))
                end
            end
            @handle msg.mouseup begin
                state = e.mousebuttonstate
                if mouseup & 1 == 0 && (Mouse.left in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.left, Mouse.release))
                end
                if mouseup & 2 == 0 && (Mouse.right in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.right, Mouse.release))
                end
                if mouseup & 4 == 0 && (Mouse.middle in state)
                    setindex!(e.mousebutton, MouseButtonEvent(Mouse.middle, Mouse.release))
                end
            end
            @handle msg.scroll begin
                e.scroll[] = Float64.((sign.(scroll)...,))
            end
            @handle msg.keydown begin
                button = code_to_keyboard(keydown[1])
                # don't add unknown buttons...we can't work with them
                # and they won't get removed
                if button != Keyboard.unknown
                    e.keyboardbutton[] = KeyEvent(button, Keyboard.press)
                end
                if length(keydown[2]) == 1 && isascii(keydown[2])
                    e.unicode_input[] = keydown[2][1]
                end
            end
            @handle msg.keyup begin
                if keyup == "delete_keys"
                    # this works fine
                    for key in e.keyboardstate
                        e.keyboardbutton[] = KeyEvent(key, Keyboard.release)
                    end
                else
                    e.keyboardbutton[] = KeyEvent(code_to_keyboard(keyup), Keyboard.release)
                end
            end
            @handle msg.resize begin
                resize!(scene, tuple(resize...))
            end
        catch err
            @warn "Error in window event callback" exception = (err, Base.catch_backtrace())
        end
        return
    end

    return
end

function connect_post_init_events(screen, scene)
    e = events(scene)
    tick_callback = Makie.TickCallback(e.tick)
    # key = rand(UInt16) # Is the right clock closing?
    Makie.start!(screen.tick_clock) do timer
        if !Makie.isclosed(scene)
            tick_callback(Makie.RegularRenderTick)
        else
            Makie.stop!(timer)
            e.window_open[] = false
        end
        return
    end
    return
end

function serialize_three(scene::Scene, plot::Makie.Voxels)

    mesh = create_shader(scene, plot)

    mesh[:plot_type] = js_plot_type(plot)
    mesh[:name] = string(Makie.plotkey(plot)) * "-" * string(objectid(plot))
    mesh[:visible] = plot.visible[]
    mesh[:uuid] = js_uuid(plot)
    mesh[:updater] = plot.attributes[:wgl_update_obs][]

    mesh[:overdraw] = plot.overdraw[]
    mesh[:transparency] = plot.transparency[]
    mesh[:space] = plot.space[]

    if haskey(plot, :markerspace)
        mesh[:markerspace] = plot.markerspace[]
        mesh[:cam_space] = plot.markerspace[]
    else
        mesh[:cam_space] = plot.space[]
    end

    mesh[:uniforms][:uniform_clip_planes] = serialize_three(plot.uniform_clip_planes[])
    mesh[:uniforms][:uniform_num_clip_planes] = serialize_three(plot.uniform_num_clip_planes[])

    return mesh
end

function create_shader(scene::Scene, plot::Voxels)
    attr = plot.attributes

    Makie.add_computation!(attr, scene, Val(:voxel_model))

    if haskey(attr, :voxel_colormap)
        map!(attr, :voxel_colormap, [:wgl_colormap, :wgl_uv_transform, :wgl_color]) do colormap
            # colormap is synchronized with the 255 values possible
            return (Sampler(colormap, minfilter = :nearest), false, false)
        end
    elseif haskey(attr, :voxel_color)
        Makie.add_computation!(attr, scene, Val(:voxel_uv_transform))
        register_computation!(
            attr, [:voxel_color, :packed_uv_transform, :interpolate],
            [:wgl_colormap, :wgl_uv_transform, :wgl_color]
        ) do inputs, changed, cached
            # how interpolate?
            color, uvt, interpolate = inputs
            filter = ifelse(interpolate, :linear, :nearest)
            if isnothing(uvt)
                return (false, false, Sampler(color, minfilter = filter)) # color vector
            else
                return (false, Sampler(uvt, minfilter = :nearest), Sampler(color, minfilter = filter)) # texture map
            end
        end
    else

    end

    Makie.register_world_normalmatrix!(attr, :voxel_model)
    Makie.add_computation!(attr, Val(:uniform_clip_planes), :model, :voxel_model)

    # TODO: this is a waste, should just be "make N instances with no data"
    register_computation!(attr, [:chunk_u8, :gap], [:dummy_data]) do (chunk, gap), changed, cached
        N = sum(size(chunk))
        N_instances = ifelse(gap > 0.01, 2 * N, N + 3)
        if isnothing(cached)
            return (zeros(Float32, N_instances),) # or smaller type?
        else
            dummy_data = cached[1]::Vector{Float32}
            if N_instances != length(dummy_data)
                resize!(dummy_data, N_instances)
                dummy_data .= 0
                return (dummy_data,)
            else
                return nothing
            end
        end
    end

    add_primitive_shading!(scene, attr)
    inputs = [
        :dummy_data,

        :depth_shift, :world_normalmatrix,
        :gap, :chunk_u8, :voxel_model,
        :wgl_colormap, :wgl_uv_transform, :wgl_color,

        :diffuse, :specular, :shininess, # :backlight,
        :depthsorting, :primitive_shading,
        :uniform_clip_planes, :uniform_num_clip_planes, :visible,
    ]

    return create_wgl_renderobject(voxel_program, attr, inputs)
end


function voxel_program(attr)
    uniforms = Dict(
        :diffuse => attr.diffuse,
        :specular => attr.specular,
        :shininess => attr.shininess,
        :picking => false,
        :object_id => UInt32(0),
        :depth_shift => attr.depth_shift,
        :eyeposition => Vec3f(1),
        :view_direction => Vec3f(1),
        :depthsorting => attr.depthsorting,
        :world_normalmatrix => attr.world_normalmatrix,
        :shading => attr.primitive_shading,
        :gap => attr.gap,
        :chunk_u8 => attr.chunk_u8,
        :voxel_model => attr.voxel_model,
        :wgl_colormap => attr.wgl_colormap,
        :wgl_uv_transform => attr.wgl_uv_transform,
        :wgl_color => attr.wgl_color,
    )

    # TODO: this is a waste, should just be "make N instances with no data"
    per_instance = Dict(:dummy_data => attr.dummy_data)
    instance = GeometryBasics.mesh(Rect2f(0, 0, 1, 1)) # dont need uv, normals

    data = create_instanced_shader(
        per_instance, instance, uniforms,
        lasset("voxel.vert"), lasset("voxel.frag")
    )

    return data
end

"""
* `framerate = 30`: Set framerate (frames per second) to a higher number for smoother animations, or to a lower to use less resources.
* `resize_to = nothing`: Resize the canvas to the parent element with `resize_to=:parent`, or to the body if `resize_to = :body`. The default `nothing`, will resize nothing.
    A tuple is allowed too, with the same values just for width/height.
* `use_html_widgets = false`: Whether to replace the Makie Block widgets with HTML native widgets.
* `spinner = automatic`: The spinner to display while the scene is loading. Use `automatic` for the default CircleSpinner, or provide a custom spinner component.
"""
struct ScreenConfig
    framerate::Float64 # =30.0
    resize_to::Any # nothing
    # We use nothing, since that serializes correctly to nothing in JS, which is important since that's where we calculate the defaults!
    # For the theming, we need to use Automatic though, since that's the Makie meaning for gets calculated somewhere else
    px_per_unit::Union{Nothing, Float64} # nothing, a.k.a the browser px_per_unit (devicePixelRatio)
    scalefactor::Union{Nothing, Float64}
    resize_to_body::Bool # deprecated, but needs to be here in the struct to correctly iterate over all screen config names
    use_html_widgets::Bool
    spinner::Any # The spinner component to show while loading
    function ScreenConfig(
            framerate::Number, resize_to::Any, px_per_unit::Union{Number, Automatic, Nothing},
            scalefactor::Union{Number, Automatic, Nothing}, resize_to_body::Union{Nothing, Bool},
            use_html_widgets::Bool, spinner::Any
        )
        if px_per_unit isa Automatic
            px_per_unit = nothing
        end
        if scalefactor isa Automatic
            scalefactor = nothing
        end
        # Construct default spinner if automatic
        if spinner isa Automatic
            spinner = CircleSpinner()
        end
        if resize_to_body isa Bool
            @warn("`resize_to_body` is deprecated, use `resize_to = :body` instead")
            if !(resize_to isa Nothing)
                @warn("Setting `resize_to_body` and `resize_to` at the same time, only use resize_to")
            else
                resize_to = resize_to_body ? :body : nothing
            end
        end
        ResizeType = Union{Nothing, Symbol}
        if !(resize_to isa Union{ResizeType, Tuple{ResizeType, ResizeType}})
            error("Only nothing, :parent, or :body allowed, or a tuple of those for width/height.")
        end
        return new(framerate, resize_to, px_per_unit, scalefactor, false, use_html_widgets, spinner)
    end
end
"""
    Screen(args...; screen_config...)

# Arguments one can pass via `screen_config`:

$(Base.doc(ScreenConfig))

# Constructors:

$(Base.doc(MakieScreen))
"""
mutable struct Screen <: Makie.MakieScreen
    plot_initialized::Channel{Any}
    session::Union{Nothing, Session}
    scene::Union{Nothing, Scene}
    displayed_scenes::Set{String}
    config::ScreenConfig
    canvas::Union{Nothing, Bonito.HTMLElement}
    tick_clock::Makie.BudgetedTimer
    lock::ReentrantLock
    function Screen(scene::Union{Nothing, Scene}, config::ScreenConfig)
        timer = Makie.BudgetedTimer(1.0 / 30.0)
        return new(Channel{Any}(1), nothing, scene, Set{String}(), config, nothing, timer, Base.ReentrantLock())
    end
end

function Makie.px_per_unit(s::Screen)::Float64
    return something(s.config.px_per_unit, 1.0)
end

Bonito.needs_post_notify(x::Makie.FigureLike) = true
function Bonito.post_notify_callback(x::Makie.FigureLike)
    scene = Makie.get_scene(x)
    return () -> poll_all_plots(scene)
end

function Screen(; config...)
    config = Makie.merge_screen_config(ScreenConfig, Dict{Symbol, Any}(config))
    return Screen(nothing, config)
end


function scene_already_displayed(screen::Screen, scene = screen.scene)
    scene === nothing && return false
    screen.scene === scene || return false
    screen.canvas === nothing && return false
    return !isnothing(screen.session) &&
        isready(screen.session) && isready(screen.plot_initialized) &&
        js_uuid(screen.scene) in screen.displayed_scenes
end

function poll_all_plots(scene)
    return Makie.for_each_atomic_plot(scene) do p
        pp = Makie.parent_scene(p)
        pp.visible[] || return nothing # Skip invisible scenes
        if haskey(p, :wgl_renderobject)
            try
                # Skip updating invisible renderobjects
                # This is basically `if is_visible || was_visible`, which makes
                # sure the robj updates on state change. (i.e. hides and redisplays)
                computed = p[:wgl_renderobject]
                if p.visible[] || computed.value[][:visible]
                    computed[]
                end
            catch e
                @error "Failed to update renderobject - skipping update" exception = (e, catch_backtrace())
                # Mark the output as resolved so we don't repeatedly pull in errors
                # TODO: Is there a better way to handle this? One that allows us to
                # shortcut mark_dirty!() (i.e. preserve parentdirty implying children dirty)
                ComputePipeline.mark_resolved!(p.attributes[:wgl_renderobject])
            end
        end
    end
end

function start_polling_loop!(screen, scene)
    scene.isclosed = false
    return Makie.async_tracked() do isrunning
        while !Makie.isclosed(scene) && isrunning[]
            try
                poll_all_plots(scene)
            catch e
                @error "Error in polling loop" exception = (e, catch_backtrace())
            end
            sleep(1 / 100)
        end
        try
            close(screen; from_close = true)
        catch e
            @error "Error closing screen in polling loop" exception = (e, catch_backtrace())
        end
    end
end

function render_with_init(screen::Screen, session::Session, scene::Scene, figure = nothing)
    # Reference to three object which gets set once we serve this to a browser
    # Make sure it's a new Channel, since we may reuse the screen.
    screen.plot_initialized = Channel{Any}(1)
    screen.session = session
    Makie.push_screen!(scene, screen)
    try
        wrapper, on_init = three_display(screen, session, scene)
        screen.canvas = wrapper
        if !isnothing(figure) && screen.config.use_html_widgets
            widgets = WGLMakie.replace_widget!(figure)
            push!(Bonito.children(wrapper), widgets)
        end
        on(session, on_init) do initialized
            if isready(screen.plot_initialized)
                # plot_initialized contains already an item
                # This should not happen, but lets check anyways, so it errors and doesn't hang forever
                error("Plot initialized multiple times?")
            end
            if initialized == true
                put!(screen.plot_initialized, true)
                mark_as_displayed!(screen, scene)
                start_polling_loop!(screen, scene)
                connect_post_init_events(screen, scene)
            else
                # Will be an error from WGLMakie.js
                put!(screen.plot_initialized, initialized)
            end
            return
        end
        on(session, session.on_close) do closed
            if closed == true
                scene.events.window_open[] = false
            end
            return
        end
        return wrapper
    catch e
        put!(screen.plot_initialized, e)
        rethrow(e)
    end
end

function Bonito.jsrender(session::Session, scene::Scene)
    screen = Screen()
    screen.scene = scene
    return Bonito.jsrender(session, render_with_init(screen, session, scene, nothing))
end

function Bonito.jsrender(session::Session, fig::Makie.FigureLike)
    Makie.update_state_before_display!(fig)
    scene = Makie.get_scene(fig)
    screen = Screen()
    screen.scene = scene
    return Bonito.jsrender(session, render_with_init(screen, session, scene, Makie.get_figure(fig)))
end


"""
    WithConfig(fig::Makie.FigureLike; screen_config...)

Allows to pass a screenconfig to a figure, inside a Bonito.App.
This circumvents using `WGLMakie.activate!(; screen_config...)` inside an App, which modifies these values globally.
Example:

```julia
App() do
    f1 = scatter(1:4)
    f2 = scatter(1:4; figure=(; backgroundcolor=:gray))
    wc = WGLMakie.WithConfig(f2; resize_to=:parent)
    DOM.div(f1, DOM.div(wc; style="height: 200px; width: 50%"))
end
```
"""
struct WithConfig
    fig::Makie.FigureLike
    config::ScreenConfig
end

function WithConfig(fig::Makie.FigureLike; kw...)
    config = Makie.merge_screen_config(ScreenConfig, Dict{Symbol, Any}(kw))
    return WithConfig(fig, config)
end

function Bonito.jsrender(session::Session, wconfig::WithConfig)
    fig = wconfig.fig
    Makie.update_state_before_display!(fig)
    scene = Makie.get_scene(fig)
    screen = Screen(scene, wconfig.config)
    return Bonito.jsrender(session, render_with_init(screen, session, scene, Makie.get_figure(fig)))
end


function Base.show(io::IO, screen::Screen)
    c = screen.config
    ppu = c.px_per_unit
    sf = c.scalefactor
    three_str = sprint(io -> show(io, MIME"text/plain"(), screen.plot_initialized))
    return print(
        io, """WGLMakie.Screen(
            framerate = $(c.framerate),
            resize_to = $(c.resize_to),
            px_per_unit = $(isnothing(ppu) ? :automatic : ppu),
            scalefactor = $(isnothing(sf) ? :automatic : sf),
            session = $(isnothing(screen.session) ? :nothing : isopen(screen.session)),
            three = $(three_str),
            scene = $(isnothing(screen.scene) ? :nothing : screen.scene),
        )"""
    )
end

# Resizing the scene is enough for WGLMakie
Base.resize!(::WGLMakie.Screen, w, h) = nothing

function Base.isopen(screen::Screen)
    # This function is used as the source of truth for dynamically setting
    # window_open[] = false (as opposed to using close()), so it can't just
    # rely on window_open. Check the session too.
    return !isnothing(screen.scene) && screen.scene.events.window_open[] &&
        !isnothing(screen.session) && isopen(screen.session)
end

function mark_as_displayed!(screen::Screen, scene::Scene)
    push!(screen.displayed_scenes, js_uuid(scene))
    for child_scene in scene.children
        mark_as_displayed!(screen, child_scene)
    end
    return
end

for M in Makie.WEB_MIMES
    @eval begin
        function Makie.backend_show(screen::Screen, io::IO, m::$M, scene::Scene, figure = nothing)
            inline_display = App(title = "WGLMakie") do session::Session
                return render_with_init(screen, session, scene, figure)
            end
            Base.show(io, m, inline_display)
            return screen
        end
    end
end

function Makie.backend_showable(::Type{Screen}, ::T) where {T <: MIME}
    return T in Makie.WEB_MIMES
end

function Base.close(screen::Screen; from_close = false)
    return @lock screen.lock begin
        scene = screen.scene
        session = nothing
        if !isnothing(screen.session) && isopen(screen.session) && !from_close
            session = Bonito.root_session(screen.session)
        end
        if !isnothing(screen.scene)
            scene = screen.scene
            filter!(x -> x !== screen, scene.current_screens)
            events(scene).window_open[] = false
            Makie.for_each_atomic_plot(scene) do plot
                delete_wgl_robj!(session, plot)
            end
        end
        Makie.stop!(screen.tick_clock)
        if !screen.tick_clock.running && isnothing(screen.scene) && (isnothing(screen.session) || !isopen(screen.session))
            # If the screen is already closed, we don't need to do anything
            return
        end
        if !isnothing(session) && !isnothing(screen.canvas) && !isnothing(scene)
            evaljs_value(
                session, js"""$(WGL).then(WGL => {
                    const canvas = $(screen.canvas);
                    const screen = canvas?.firstElementChild?.wglmakie_screen
                    if (screen) {
                        console.log("Disposing screen", screen);
                        WGL.dispose_screen(screen)
                    }
                })
                """
            )
        end
        return
    end
end

function Base.size(screen::Screen)
    return size(screen.scene)
end

function get_screen_session(
        screen::Screen; timeout = 100,
        error::Union{Nothing, String} = nothing
    )::Union{Nothing, Session}
    function maybe_throw(status)
        return if !isnothing(error)
            message = "Can't get three: $(status)\n$(error)"
            Base.error(message)
        else
            # @warn "Can't get three: $(status)\n$(error)"
        end
    end
    if isnothing(screen.session)
        maybe_throw("Screen has no session. Not yet displayed?")
        return nothing
    end
    session = screen.session
    if !(session.status in (Bonito.RENDERED, Bonito.DISPLAYED, Bonito.OPEN))
        maybe_throw("Screen Session uninitialized. Not yet displayed? Session status: $(screen.session.status), id: $(session.id)")
        return nothing
    end
    success = Bonito.wait_for_ready(session; timeout = timeout)
    success === :closed && return nothing
    if success !== :success
        maybe_throw("Timed out waiting for session to get ready")
        return nothing
    end
    success = Bonito.wait_for(timeout = timeout) do
        Bonito.isclosed(session) && return :closed
        isready(screen.plot_initialized)
    end
    # session closed inbetween, nothing can be done
    success === :closed && return nothing
    # Throw error if error message specified
    if success !== :success || !isopen(session)
        maybe_throw("Timed out waiting $(timeout)s for session to get initialize")
        return nothing
    end
    value = fetch(screen.plot_initialized)
    if value !== true
        maybe_throw("Error initializing plot: $(value)")
        return nothing
    end
    # At this point we should have a fully initialized plot + session
    return session
end

function Makie.apply_screen_config!(screen::Screen, config::ScreenConfig, args...)
    #TODO implement
    return screen
end

# TODO, create optimized screens, forward more options to JS/WebGL
function Screen(scene::Scene; kw...)
    config = Makie.merge_screen_config(ScreenConfig, Dict{Symbol, Any}(kw))
    screen = Screen(scene, config)
    return screen
end

function Screen(scene::Scene, config::ScreenConfig, ::IO, ::MIME)
    screen = Screen(scene, config)
    return screen
end

function Screen(scene::Scene, config::ScreenConfig, ::Makie.ImageStorageFormat)
    screen = Screen(scene, config)
    return screen
end

function Base.empty!(screen::Screen)
    screen.scene = nothing
    screen.plot_initialized = Channel{Any}(1)
    return
    # TODO, empty state in JS, to be able to reuse screen
end

Makie.wait_for_display(screen::Screen) = get_screen_session(screen)

function Base.display(screen::Screen, scene::Scene; figure = nothing, unused...)
    # already displayed!
    if scene_already_displayed(screen, scene)
        return screen
    end
    app = App(title = "WGLMakie") do session
        return render_with_init(screen, session, scene, figure)
    end
    display(app)
    Bonito.wait_for(() -> !isnothing(screen.session))
    Bonito.wait_for_ready(screen.session)
    # wait for plot to be full initialized, so that operations don't get racy (e.g. record/RamStepper & friends)
    get_screen_session(screen; error = "Waiting for plot to be initialized in display")
    return screen
end

function session2image(session::Session, scene::Scene)
    to_data = js"""function (){
        return $(scene).then(scene => {
            const {renderer} = scene.screen
            WGL.render_scene(scene)
            const img = renderer.domElement.toDataURL()
            return img
        })
    }()
    """
    picture_base64 = Bonito.evaljs_value(session, to_data; timeout = 100)
    picture_base64 = replace(picture_base64, "data:image/png;base64," => "")
    bytes = Bonito.Base64.base64decode(picture_base64)
    return PNGFiles.load(IOBuffer(bytes))
end

function Makie.colorbuffer(screen::Screen; figure = nothing)
    if isnothing(screen.session)
        Base.display(screen, screen.scene; figure = figure)
    end
    session = get_screen_session(screen; error = "Not able to show scene in a browser")
    poll_all_plots(screen.scene)
    return session2image(session, screen.scene)
end

function insert_scene!(session::Session, screen::Screen, scene::Scene)
    if js_uuid(scene) in screen.displayed_scenes
        return true
    else
        if !(js_uuid(scene.parent) in screen.displayed_scenes)
            # Parents serialize their child scenes, so we only need to
            # serialize & update the parent scene
            return insert_scene!(session, screen, scene.parent)
        end
        scene_ser = serialize_scene(scene)
        parent = scene.parent
        parent_uuid = js_uuid(parent)
        err = "Cannot find scene js_uuid(scene) == $(parent_uuid)"
        evaljs_value(
            session, js"""
            $(WGL).then(WGL=> {
                const parent = WGL.find_scene($(parent_uuid));
                if (!parent) {
                    throw new Error($(err))
                }
                const new_scene = WGL.deserialize_scene($scene_ser, parent.screen);
                parent.scene_children.push(new_scene);
            })
            """
        )
        mark_as_displayed!(screen, scene)
        return false
    end
end

function insert_plot!(session::Session, scene::Scene, @nospecialize(plot::Plot))
    plot_data = serialize_plots(scene, Plot[plot])
    # serialize + evaljs via sub session, so we can keep track of those observables
    js = js"""
    $(WGL).then(WGL=> {
        WGL.insert_plot($(js_uuid(scene)), $plot_data);
    })"""
    Bonito.evaljs_value(session, js; timeout = 10, error_on_closed = false)
    return
end

function Base.insert!(::Screen, ::Scene, @nospecialize(plot::PlotList))
    return nothing
end

function Base.insert!(screen::Screen, scene::Scene, @nospecialize(plot::Plot))
    session = get_screen_session(screen; error = "Plot needs to be displayed to insert additional plots")
    if js_uuid(scene) in screen.displayed_scenes
        insert_plot!(session, scene, plot)
    else
        # Newly created scene gets inserted!
        # This must be a child plot of some parent, otherwise a plot wouldn't be inserted via `insert!(screen, ...)`
        parent = scene.parent
        @assert parent !== scene
        if isnothing(parent)
            # This shouldn't happen, since insert! only gets called for scenes, that already got displayed on a screen
            error("Scene has no parent, but hasn't been displayed yet")
        end
        # We serialize the whole scene (containing `plot` as well),
        # since, we should only get here if scene is newly created and this is the first plot we insert!
        @assert scene.plots[1] == plot
        insert_scene!(session, screen, scene)
    end
    return
end


function all_plots_scenes(scene::Scene; scene_uuids = String[], plots = Plot[])
    push!(scene_uuids, js_uuid(scene))
    append!(plots, scene.plots)
    for child in scene.children
        all_plots_scenes(child; plots = plots, scene_uuids = scene_uuids)
    end
    return scene_uuids, plots
end

function delete_wgl_robj!(session::Union{Nothing, Session}, plot::Plot)
    # Delete the renderobject, so that we can free the memory
    if haskey(plot.attributes, :wgl_renderobject)
        delete!(plot.attributes, :wgl_renderobject, force = true)
    end
    if haskey(plot.attributes, :wgl_update_obs)
        obs = plot.attributes[:wgl_update_obs][]
        delete!(plot.attributes, :wgl_update_obs)
        if !isnothing(session)
            root = Bonito.root_session(session)
            Bonito.delete_cached!(root, root, obs.id)
        end
    end
    return
end


# Can be called from finalizer!
function Base.delete!(screen::Screen, ::Scene, plot::Plot)
    # # only queue atomics to actually delete on js
    atomics = Makie.collect_atomic_plots(plot)
    session = get_screen_session(screen)
    for plot in atomics
        delete_wgl_robj!(session, plot)
    end
    plot_uuids = map(js_uuid, atomics)
    isnothing(session) && return # if no session we haven't displayed and dont need to delete
    # Eval in root session, since main_session might be gone (e.g. getting closed just shortly before freeing the plots)
    root = Bonito.root_session(session)
    isready(root) || return nothing
    Bonito.evaljs(
        root, js"""
        $(WGL).then(WGL=> {
            WGL.delete_plots($(plot_uuids));
        })"""
    )
    return
end


function Base.delete!(screen::Screen, scene::Scene)
    delete!(screen.displayed_scenes, js_uuid(scene))
    session = get_screen_session(screen)
    isnothing(session) && return # if no session we haven't displayed and dont need to delete
    # Eval in root session, since main_session might be gone (e.g. getting closed just shortly before freeing the plots)
    root = Bonito.root_session(session)
    isready(root) || return nothing
    scene_uuids, plots = all_plots_scenes(scene)
    for plot in plots
        delete_wgl_robj!(root, plot)
    end
    Bonito.evaljs_value(
        root, js"""
        $(WGL).then(WGL=> {
            WGL.delete_scenes($scene_uuids, $(js_uuid.(plots)));
        })"""
    )
    return
end

import ShaderAbstractions as SA

# Use highp precision to avoid float overflows in uniforms (e.g. preprojection
# matrices for 3D scatter plots can produce values exceeding the f16 range that
# `mediump` uses on some drivers, leading to Inf values and missing geometry).
const SHADER_PRECISION_HEADER = """
#version 300 es
precision highp int;
precision highp float;
precision highp sampler2D;
precision highp sampler3D;
precision highp isampler2D;
precision highp isampler3D;
precision highp usampler2D;
precision highp usampler3D;
"""

to_vertex_dict(dict::Dict) = dict

to_face_buffer(xx::Vector{UInt32}) = xx
function to_face_buffer(xx)
    return collect(reinterpret(UInt32, xx))
end

function to_vertex_dict(mesh::AbstractGeometry)
    va = Dict{Symbol, AbstractVector}()
    for (k, v) in pairs(GeometryBasics.vertex_attributes(mesh))
        va[k] = v
    end
    va[:faces] = to_face_buffer(decompose(GLTriangleFace, mesh))
    return va
end


function serialize_named_buffer(va::Dict)
    result = Dict{Symbol, Any}()
    for (name, buff) in va
        name == :faces && continue
        result[name] = serialize_buffer_attribute(buff)
    end
    return result
end

function create_shader(vertex_attr, uniforms, vertshader, fragshader)
    context = WebGL()
    vertex_dict = to_vertex_dict(vertex_attr)
    # For vertex_attributes with varying names we set a backup in uniforms
    # Which needs to be removed, when they actually come from the mesh/vertex_attributes
    for (name, element) in vertex_dict
        delete!(uniforms, name)
    end
    # remove faces from vertex attributes
    uniform_block = sprint() do io
        println(io, "\n// Uniforms: ")
        for (name, v) in uniforms
            endswith(string(name), "_getter") && continue
            t_str = try
                SA.type_string(context, v)
            catch e
                @error("Type $(typeof(v)) isn't supported for uniform: $(name)")
                rethrow(e)
            end
            println(io, "uniform ", t_str, " $name;")
            getkey = Symbol(string(name, "_", "getter"))
            if !haskey(uniforms, getkey)
                SA.getter_function(io, v, t_str, name)
            end
        end
        # emit getter after uniforms
        for (name, v) in uniforms
            getkey = Symbol(string(name, "_", "getter"))
            if haskey(uniforms, getkey)
                println(io, uniforms[getkey])
            end
        end

        println(io)
    end
    src = sprint() do io
        println(io, "// vertex inputs: ")
        for (name, element) in vertex_dict
            name == :faces && continue
            SA.input_element(context, SA.Vertex(), io, element, name, uniforms)
        end
        println(io, uniform_block)
        println(io)
        println(io, vertshader)
    end
    vert = SHADER_PRECISION_HEADER * src
    frag = SHADER_PRECISION_HEADER * "\nout vec4 fragment_color;\n" * uniform_block * fragshader
    up(x) = replace(x, "#version 300 es" => "")
    filter!(((name, _),) -> !endswith(string(name), "_getter"), uniforms)
    return Dict(
        :vertexarrays => serialize_named_buffer(vertex_dict),
        :faces => to_face_buffer(vertex_dict[:faces]),
        :uniforms => serialize_uniforms(uniforms),
        :vertex_source => up(vert),
        :fragment_source => up(frag),
    )
end

function create_instanced_shader(per_instance, vertexbuffers, uniforms, vertshader, fragshader)
    instance_attributes = sprint() do io
        println(io, "\n// Per instance attributes: ")
        for (name, element) in per_instance
            SA.input_element(WebGL(), SA.Vertex(), io, element, name, uniforms)
        end
        println(io)
    end
    data = create_shader(vertexbuffers, uniforms, instance_attributes * vertshader, fragshader)
    data[:instance_attributes] = serialize_named_buffer(per_instance)
    return data
end

# Reference test for WGLMakie HTML widgets
# This test verifies that all widgets render correctly with proper positioning when use_html_widgets=true

using ReferenceTests: RNG, @reference_test
using ReferenceTests, WGLMakie
using Test
import Electron, Bonito

struct EScreenshot
    display
    app::Bonito.App
    capture_full_page::Bool
    # Figures whose render we block on before screenshotting (via
    # `get_screen(fig).plot_initialized`). For `App`s that embed figures, pass them
    # explicitly since we can't recover them from the app.
    figures::Vector{Any}
end

EScreenshot(display, fig::Makie.FigureLike; capture_full_page = false) = EScreenshot(display, App(fig), capture_full_page, Any[fig])
EScreenshot(display, app::Bonito.App; figures = Any[]) = EScreenshot(display, app, true, figures)  # Default to full page for App tests

# Block until every figure has finished its initial render — i.e. `done_init`
# fired, which now means resized-to-parent and painted (see `three_plot.jl` /
# `WGLMakie.js`). This is the source of truth, replacing a fixed sleep. The screen
# is attached during rendering, so wait for it too.
function wait_for_plots(figures; timeout = 60)
    for fig in figures
        scene = Makie.get_scene(fig)
        ok = Bonito.wait_for(timeout = timeout) do
            screen = Makie.getscreen(scene)
            screen !== nothing && isready(screen.plot_initialized)
        end
        if ok != :success
            @warn "figure did not report plot_initialized in time"
            continue
        end
        value = fetch(Makie.getscreen(scene).plot_initialized)   # fetch peeks, leaves it in the channel
        value === true || @warn "figure reported an init error" value
    end
    return
end

function snapshot_figure(edisplay, app, path; capture_full_page = false, figures = Any[])
    rm(path; force = true)
    display(edisplay, app)
    win = edisplay.window.window
    Bonito.wait_for_ready(app)
    wait_for_plots(figures)   # block until every figure is resized-to-parent and painted
    win_size = run(
        win, """(()=>{
            document.body.style.margin = '0';
            document.body.style.padding = '0';
            document.documentElement.style.margin = '0';
            document.documentElement.style.padding = '0';
            document.body.style.overflow = 'hidden'; // Prevent scrollbars

            if ($capture_full_page) {
                // Capture the full body content for testing HTML layouts.
                // Measure the bounding box of the actual content, not viewport
                // dimensions.
                //
                // Bonito wraps the app in `display:contents` fragment divs
                // (`bonito-fragment`). Such elements generate no layout box, so
                // `getBoundingClientRect()` on them is all-zero - iterating
                // `body.children` directly would collapse the measured content
                // height to the body margins. Descend through any
                // `display:contents` wrapper to reach the real content boxes
                // (this reproduces the measurement from before Bonito inserted
                // the fragment wrappers).
                let maxRight = 0;
                let maxBottom = 0;
                const measure = (el) => {
                    for (const child of el.children) {
                        if (getComputedStyle(child).display === "contents") {
                            measure(child);
                        } else {
                            const rect = child.getBoundingClientRect();
                            maxRight = Math.max(maxRight, rect.right);
                            maxBottom = Math.max(maxBottom, rect.bottom);
                        }
                    }
                };
                measure(document.body);

                // If nothing measurable was found, fall back to scrollWidth/Height
                const width = maxRight > 0 ? maxRight : document.body.scrollWidth;
                const height = maxBottom > 0 ? maxBottom : document.body.scrollHeight;

                return [Math.ceil(width), Math.ceil(height)];
            } else {
                // Find the canvas element (Makie renders to canvas)
                const canvas = document.querySelector('canvas');
                const rect = canvas.getBoundingClientRect();
                return [
                    Math.ceil(rect.width),
                    Math.ceil(rect.height)
                ];
            }
        })();
        """
    )
    Electron.ElectronAPI.setContentSize(win, win_size...)
    sleep(1) # give the resize round-trip a chance to start
    wait_for_render(win)
    winid = win.id
    js_path = replace(path, '\\' => '/')
    run(
        edisplay.window.app,
        """
        const win = BrowserWindow.fromId($winid)
        win.webContents.capturePage().then(image => {
            require('fs').writeFileSync('$(js_path)', image.toPNG());
        }).catch(err => console.error('Screenshot error:', err));
        """,
    )
    Bonito.wait_for(() -> isfile(path); timeout = 30)
    return path
end

# A `resize_to` canvas is resized only when the Julia `viewport(scene)` round-trip
# lands (WGLMakie.js `canvas_width` -> `renderer.setSize`), and it re-renders right
# after. So wait (via rAF, no busy Julia loop) until every canvas size holds steady
# for a few frames, then one more frame to paint — robust even when a loaded CI
# runner drags the round-trip out well past a fixed sleep.
function wait_for_render(win; stable = 5, max_frames = 1800)
    run(
        win, """
        new Promise((resolve) => {
            let prev = "", steady = 0, frames = 0;
            const dims = () => [...document.querySelectorAll('canvas')].map(c => c.width + "x" + c.height).join("|");
            const tick = () => {
                const d = dims();
                steady = d === prev ? steady + 1 : 0;
                prev = d;
                (steady >= $stable || ++frames > $max_frames) ?
                    requestAnimationFrame(() => resolve(true)) : requestAnimationFrame(tick);
            };
            requestAnimationFrame(tick);
        })
        """
    )
    return
end

# YAY we can just overload save_results for our own EScreenshot type :)
function ReferenceTests.save_result(path::String, es::EScreenshot)
    isfile(path * ".png") && rm(path * ".png"; force = true)
    snapshot_figure(es.display, es.app, path * ".png"; capture_full_page = es.capture_full_page, figures = es.figures)
    return true
end

# Simple ResizableCard replacement for testing (mimics Splots.ResizableCard behavior)
function TestResizableCard(content; style = Bonito.Styles())
    card_style = Bonito.Styles(
        style,
        Bonito.CSS(
            "position" => "relative",
            "overflow" => "hidden",
            "background-color" => "rgba(1, 1, 1, 0.2)",
            "box-shadow" => "0 4px 8px rgba(0, 0, 0, 0.2)",
            "padding" => "7px",
            "margin" => "2px",
            "border-radius" => "10px"
        )
    )
    return DOM.div(content; style = card_style)
end

function create_test_figure()
    fig = Figure(size = (1200, 900))

    # Top row - Plots with vertical slider next to ax2
    ax1 = Axis(fig[1, 1], title = "Sine Wave (Slider controlled)")
    ax2 = Axis(fig[1, 2], title = "Scatter (Button controlled)")
    sl_vertical = Makie.Slider(fig[1, 3], range = 0:0.1:10, startvalue = 5, horizontal = false)
    ax3 = Axis(fig[1, 4], title = "Heatmap (Menu controlled)")

    # Row 2 - Horizontal sliders with labels
    Label(fig[2, 1], "Frequency:", halign = :right, tellwidth = false)
    sl_freq = Makie.Slider(fig[2, 2:3], range = 0.5:0.1:5, startvalue = 2, tellwidth = false)
    freq_label = Label(fig[2, 4], lift(x -> "$(round(x, digits = 1))", sl_freq.value), halign = :left, tellwidth = false)

    Label(fig[3, 1], "Amplitude:", halign = :right, tellwidth = false)
    sl_amp = Makie.Slider(fig[3, 2:3], range = 0.5:0.1:3, startvalue = 1.5, tellwidth = false)
    amp_label = Label(fig[3, 4], lift(x -> "$(round(x, digits = 1))", sl_amp.value), halign = :left, tellwidth = false)

    Label(fig[4, 1], "Phase:", halign = :right, tellwidth = false)
    sl_phase = Makie.Slider(fig[4, 2:3], range = 0:0.1:2π, startvalue = 0, tellwidth = false)
    phase_label = Label(fig[4, 4], lift(x -> "$(round(x, digits = 2))", sl_phase.value), halign = :left, tellwidth = false)

    # Row 5 - Buttons
    btn_add = Makie.Button(fig[5, 2:3], label = "Add Point", tellwidth = false)
    click_counter = Label(fig[5, 4], lift(n -> "Total: $n clicks", btn_add.clicks), halign = :left, tellwidth = false)

    # Row 6 - Menus
    Label(fig[6, 1], "Colormap:", halign = :right, tellwidth = false)
    menu_cmap = Makie.Menu(fig[6, 2], options = ["viridis", "plasma", "inferno", "magma"], default = "viridis", tellwidth = false)

    num_func = GridLayout(fig[6:7, 3:4])
    Label(num_func[1, 1], "Function:"; halign = :right, tellwidth = false)
    funcs = [sin, cos, tan]
    menu_func = Makie.Menu(
        num_func[1, 2];
        options = zip(["Sine", "Cosine", "Tangent"], funcs),
        default = "Sine", tellwidth = false
    )

    # Row 7 - Textboxes
    Label(fig[7, 1], "Text input:", halign = :right, tellwidth = false)
    textbox_text = Makie.Textbox(fig[7, 2], placeholder = "Type here...", stored_string = "Hello!", tellwidth = false)

    Label(num_func[2, 1], "Number:"; halign = :right, tellwidth = false)
    textbox_num = Makie.Textbox(num_func[2, 2]; validator = Float64, stored_string = "3.14", tellwidth = false)

    # Row 8 - Checkboxes
    Label(fig[8, 1], "Enable feature:", halign = :right, tellwidth = false)
    checkbox_feature = Makie.Checkbox(fig[8, 2], checked = true, tellwidth = false)

    Label(fig[8, 3], "Show grid:", halign = :right, tellwidth = false)
    checkbox_grid = Makie.Checkbox(fig[8, 4], checked = false, tellwidth = false)

    # Row 9 - Toggles
    Label(fig[9, 1], "Dark mode:", halign = :right, tellwidth = false)
    toggle_dark = Makie.Toggle(fig[9, 2], active = false, tellwidth = false)

    Label(fig[9, 3], "Auto-update:", halign = :right, tellwidth = false)
    toggle_update = Makie.Toggle(fig[9, 4], active = true, tellwidth = false)

    # Plot 1: Sine wave controlled by sliders
    xs = 0:0.01:10
    ys = lift(sl_freq.value, sl_amp.value, sl_phase.value) do freq, amp, phase
        amp .* sin.(freq .* xs .+ phase)
    end
    sine_line = lines!(ax1, xs, ys, linewidth = 3, color = :blue)

    # Connect checkbox to control sine wave visibility
    on(checkbox_feature.checked) do checked
        sine_line.visible[] = checked
    end

    # Plot 2: Scatter plot controlled by buttons and vertical slider
    points = Observable(Point2f[])
    scatter!(ax2, points, color = :red, markersize = 15)
    on(btn_add.clicks) do n
        new_point = Point2f(RNG.rand() * 10, sl_vertical.value[])
        push!(points[], new_point)
        notify(points)
    end
    # Current position indicator
    current_marker = lift(sl_vertical.value) do y
        [Point2f(5, y)]
    end
    scatter!(ax2, current_marker, color = :green, markersize = 25, marker = :cross)
    limits!(ax2, 0, 10, 0, 10)

    # Connect checkbox to control grid visibility
    on(checkbox_grid.checked) do checked
        ax2.xgridvisible[] = checked
        ax2.ygridvisible[] = checked
    end

    # Plot 3: Heatmap controlled by menu
    data = RNG.randn(25, 25)
    hmap = heatmap!(ax3, data, colormap = menu_cmap.selection)

    # Connect toggles to control plot features
    on(toggle_dark.active) do active
        # Toggle background color
        color = to_color(active ? :gray20 : :white)
        foreach((ax1, ax2, ax3)) do ax
            ax.backgroundcolor[] = color
        end
    end

    # Bottom row - Live text preview
    preview_text = lift(textbox_text.displayed_string, textbox_num.displayed_string, toggle_update.active) do text, num, auto
        status = auto ? "Auto-update: ON" : "Auto-update: OFF"
        "Preview: \"$text\" | Number: $num | $status"
    end
    Label(fig[10, 1:4], preview_text, fontsize = 18, color = :gray50, tellwidth = false)

    # Show modified function plot
    modified_xs = 0:0.1:10
    modified_ys = lift(menu_func.selection, textbox_num.stored_string) do f, numstr
        multiplier = something(tryparse(Float64, numstr), 1.0)
        multiplier .* f.(modified_xs) .+ 5
    end
    lines!(ax2, modified_xs, modified_ys, color = :orange, linewidth = 4)

    # Manipulate all widgets to test that they update correctly in HTML
    # This verifies bidirectional sync between Julia and HTML widgets
    for i in 1:3
        btn_add.clicks[] = btn_add.clicks[] + 1
    end
    set_close_to!(sl_freq, 3.5)
    set_close_to!(sl_amp, 2.0)
    set_close_to!(sl_phase, π)
    set_close_to!(sl_vertical, 7.5)
    menu_cmap.i_selected[] = 3  # Select "inferno"
    menu_func.i_selected[] = 2  # Select "Cosine"
    Makie.set!(textbox_text, "Updated!")
    Makie.set!(textbox_num, "2.71")
    checkbox_grid.checked[] = false
    toggle_dark.active[] = true
    # Simulate 3 clicks
    return fig
end

# Makie.inline!(Makie.automatic)
edisplay = Bonito.use_electron_display(; devtools = true)
# ReferenceTests.RECORDING_DIR[] = joinpath(pwd(), "WidgetTests")
# ReferenceTests.REGISTERED_TESTS |> empty!
function close_devtools(w)
    return run(w.app, "electron.BrowserWindow.fromId($(w.id)).webContents.closeDevTools()")
end

# Devtools cut off the screenshot!
close_devtools(edisplay.window.window)

@reference_test "Widgets layout" begin
    WGLMakie.activate!(; use_html_widgets = false, px_per_unit = Makie.automatic, scalefactor = Makie.automatic)
    fig = create_test_figure()
    EScreenshot(edisplay, fig)
end

@reference_test "HTML Widgets layout" begin
    WGLMakie.activate!(; use_html_widgets = true, px_per_unit = Makie.automatic, scalefactor = Makie.automatic)
    fig = create_test_figure()
    EScreenshot(edisplay, fig)
end

@reference_test "HTML Widgets layout px_per_unit=1" begin
    WGLMakie.activate!(; use_html_widgets = true, px_per_unit = 1, scalefactor = 1)
    fig = create_test_figure()
    EScreenshot(edisplay, fig)
end

@reference_test "HTML Widgets layout px_per_unit=2" begin
    WGLMakie.activate!(; use_html_widgets = true, px_per_unit = 2, scalefactor = 2)
    fig = create_test_figure()
    EScreenshot(edisplay, fig)
end

@reference_test "resize_to parent with fixed size div" begin
    fig = create_test_figure()
    app = App() do
        DOM.div(
            DOM.h2("resize_to=:parent Test"; style = "text-align: center; color: #666;"),
            DOM.div(
                WGLMakie.WithConfig(fig; use_html_widgets = true, resize_to = :parent);
                style = "width: 1000px; height: 800px; border: 2px solid blue; margin: 10px;",
            ),
        )
    end
    EScreenshot(edisplay, app; figures = [fig])
end

@reference_test "resize_to parent with ResizableCard" begin
    fig = create_test_figure()
    app = App() do
        card = TestResizableCard(WGLMakie.WithConfig(fig; use_html_widgets = true, resize_to = :parent))
        DOM.div(
            DOM.h2("ResizableCard Test"; style = "text-align: center; color: #666;"),
            DOM.div(card; style = "width: 900px; height: 700px; margin: 10px;"),
        )
    end
    EScreenshot(edisplay, app; figures = [fig])
end

@reference_test "resize_to parent nested in styled container" begin
    fig = create_test_figure()
    app = App() do
        DOM.div(
            DOM.h2("Nested Container Test"; style = "text-align: center; color: #666;"),
            DOM.div(
                DOM.div(
                    WGLMakie.WithConfig(fig; use_html_widgets = true, resize_to = :parent);
                    style = "width: 100%; height: 100%;",
                );
                style = "width: 1100px; height: 850px; padding: 20px; background-color: #f0f0f0; border-radius: 8px; margin: 10px;",
            ),
        )
    end
    EScreenshot(edisplay, app; figures = [fig])
end

@reference_test "resize_to parent with multiple figures side by side" begin
    fig1 = Figure(; size = (600, 400))
    ax1 = Axis(fig1[1, 1]; title = "Left Plot")
    sl1 = Makie.Slider(fig1[2, 1]; range = 0:0.1:10, startvalue = 5)
    lines!(ax1, 0:0.1:10, lift(v -> sin.((0:0.1:10) .+ v), sl1.value))

    fig2 = Figure(; size = (600, 400))
    ax2 = Axis(fig2[1, 1]; title = "Right Plot")
    sl2 = Makie.Slider(fig2[2, 1]; range = 0:0.1:10, startvalue = 3)
    lines!(ax2, 0:0.1:10, lift(v -> cos.((0:0.1:10) .+ v), sl2.value))

    app = App() do
        DOM.div(
            DOM.h2("Side by Side Test"; style = "text-align: center; color: #666;"),
            DOM.div(
                DOM.div(
                    WGLMakie.WithConfig(fig1; use_html_widgets = true, resize_to = :parent);
                    style = "width: 100%; height: 100%;",
                ),
                DOM.div(
                    WGLMakie.WithConfig(fig2; use_html_widgets = true, resize_to = :parent);
                    style = "width: 100%; height: 100%;",
                );
                style = "display: flex; gap: 20px; padding: 10px; flex-wrap: wrap;",
            ),
        )
    end
    EScreenshot(edisplay, app; figures = [fig1, fig2])
end

@reference_test "resize_to body baseline" begin
    fig = create_test_figure()
    app = Bonito.App() do
        DOM.div(
            WGLMakie.WithConfig(fig; use_html_widgets = true, resize_to = :body);
            style = "margin: 0; padding: 0;",
        )
    end
    EScreenshot(edisplay, app; figures = [fig])
end

# Reset to default
WGLMakie.activate!(; use_html_widgets = false, px_per_unit = Makie.automatic, scalefactor = Makie.automatic)

# Spinner components for loading indication

"""
    CircleSpinner(; size=40, stroke=4, color="currentColor", background_color="rgba(0, 0, 0, 0.1)", duration=1)

A circular CSS spinner component that shows a loading animation.
This is the default spinner for WGLMakie scene loading.

CircleSpinner is a struct that creates a fresh DOM element on each render via `Bonito.jsrender`,
ensuring that each scene gets its own spinner instance (avoiding shared DOM issues).

# Arguments
- `size`: The diameter of the spinner in pixels (default: 40)
- `stroke`: The width of the spinner border in pixels (default: 4)
- `color`: The color of the spinning part (default: "currentColor")
- `background_color`: The color of the background circle (default: "rgba(0, 0, 0, 0.1)")
- `duration`: The speed of the rotation animation in seconds (default: 1)

# Example
```julia
# Use default spinner
WGLMakie.activate!()

# Customize spinner appearance
spinner = WGLMakie.CircleSpinner(size=60, stroke=6, color="blue")
WGLMakie.activate!(; spinner=spinner)
```

# Custom Spinners

To create your own custom spinner, define a struct and implement `Bonito.jsrender`:

```julia
struct MySpinner
    message::String
end

function Bonito.jsrender(session::Session, spinner::MySpinner)
    styles = Bonito.Styles(...)
    return Bonito.jsrender(session, DOM.div(styles, spinner.message; class="wglmakie-spinner"))
end
```

The `wglmakie-spinner` class is required for WGLMakie to find and remove the spinner after loading.
"""
struct CircleSpinner
    size::Int
    stroke::Int
    color::String
    background_color::String
    duration::Float64
end

function CircleSpinner(;
        size::Int = 40,
        stroke::Int = 4,
        color::String = "currentColor",
        background_color::String = "rgba(0, 0, 0, 0.1)",
        duration::Real = 1
    )
    return CircleSpinner(size, stroke, color, background_color, Float64(duration))
end

function Bonito.jsrender(session::Bonito.Session, spinner::CircleSpinner)
    (; size, stroke, color, background_color, duration) = spinner

    keyframes = Bonito.CSS(
        "@keyframes wglmakie-spin",
        Bonito.CSS("0%", "transform" => "translate(-50%, -50%) rotate(0deg)"),
        Bonito.CSS("100%", "transform" => "translate(-50%, -50%) rotate(360deg)"),
    )

    styles = Bonito.Styles(
        Bonito.CSS(
            ".wglmakie-spinner",
            "position" => "absolute",
            "top" => "50%",
            "left" => "50%",
            "transform" => "translate(-50%, -50%)",
            "width" => "$(size)px",
            "height" => "$(size)px",
            "border" => "$(stroke)px solid $(background_color)",
            "border-top" => "$(stroke)px solid $(color)",
            "border-radius" => "50%",
            "animation" => "wglmakie-spin $(duration)s linear infinite",
            "z-index" => "1000",
            "pointer-events" => "none",
        ),
        keyframes,
    )

    return Bonito.jsrender(session, DOM.div(styles; class = "wglmakie-spinner"))
end
